---------------------------------------------------------------------------------------------------------
-- Lootomatic - Locales for ENGLISH Clients
--
-- written by PetraAreon
-- released under the Creative Commons License By-Nc-Sa: http://creativecommons.org/licenses/by-nc-sa/3.0/
--
-- Get the current version at:   http://rom.curse.com/downloads/rom-addons/details/lootomatic.aspx
----------------------------------------------------------------------------------------------------------
-- Information for translators:
--
--   modified line 42 (RollFrameSave)
--     Changed "Ctrl+Shift+Click" to "Shift+Click"; was too complicated to handle
--   added lines 47-50 (Removed1, Removed2, NotFound1, NotFound2)
--     these contain systemmessages, when an item has been removed from the itemfilter via the DropTab
--   added line 105 (Settings_RollNewStyle)
--     new option in the settingsframe, to write rollresults in lootomatic-style (item - player - result)
--   restructured the syntax of the locales, makes it easier to replace missing strings with fallback
----------------------------------------------------------------------------------------------------------


----------------------------------------------------------------------------------------------------------
---------- Keywords, that can be used in the itemfilter --------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Keywords.none  = "none";
Lootomatic.Keywords.quest = "quest";
Lootomatic.Keywords.craft = "craft";
Lootomatic.Keywords.rune  = "rune"; -- Grade of rune gets appended! i.e. "rune1"
Lootomatic.Keywords.ammo  = "ammo";



----------------------------------------------------------------------------------------------------------
---------- Strings that are written in the chatframe -----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Loaded						= "loaded, type \"|cffFFFE80/lootomatic|r\" or use the minimap-button for settings.";
Lootomatic.Strings.Updated						= "Detected new version <VERSION>, please check your settings.";
Lootomatic.Strings.RollChange					= "The rollsettings have been changed to <ROLLSETTING>!";
Lootomatic.Strings.Description					= "Lootomatic handles everything concerning looting, as rollsetting, autoloot, autopass and autogreed. Everything is controlable via the rarity or the itemname.";
Lootomatic.Strings.AddFilter					= "Add ItemFilter";
Lootomatic.Strings.AddQuickFilter1				= "Rollingbehaviour for item |cffFFFE80\"<ITEM>\"|r has been added with the setting |cffFFFE80\"<ROLL>\"|r to the global ItemFilter.";
Lootomatic.Strings.AddQuickFilter2				= "Rollingbehaviour for item |cffFFFE80\"<ITEM>\"|r has been added with the setting |cffFFFE80\"<ROLL>\"|r to the character's ItemFilter.";
Lootomatic.Strings.RollFrameSave				= "\n|cff00c0f3Ctrl+Click|r, to save this behaviour in the global ItemFilter.\n|cff00c0f3Shift+Click|r, to save this behaviour in the character's ItemFilter.";
Lootomatic.Strings.DropTab1						= "DropTab";
Lootomatic.Strings.DropTab2						= "Drag an Item from your bag onto this symbol and drop it in one of the squares inside the poping window, to add an entry of this item to the Itemfilter. Leftclick adds it to the common Itemfilter, Rightclick to the characterspecific.";
Lootomatic.Strings.Added1						= "The item \"<ITEM>\" has been added to the common ItemFilter with the settings <SETTINGS>.";
Lootomatic.Strings.Added2						= "The item \"<ITEM>\" has been added to the characterspecific ItemFilter with the settings <SETTINGS>.";
Lootomatic.Strings.Removed1						= "The item \"<ITEM>\" has been removed from the common ItemFilter.";
Lootomatic.Strings.Removed2						= "The item \"<ITEM>\" has been removed from the characterspecific ItemFilter.";
Lootomatic.Strings.NotFound1					= "The item \"<ITEM>\" wasn't found in the common ItemFilter.";
Lootomatic.Strings.NotFound2					= "The item \"<ITEM>\" wasn't found in the characterspecific ItemFilter.";
Lootomatic.Strings.ClearBackup					= "The backup has been removed from the char-specific Savevariable.lua ";
Lootomatic.Strings.CreateBackup					= "A backup was created in the char-specific Savevariable.lua ";


----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the minimap menue ----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Enabled						= "ENABLED!";
Lootomatic.Strings.Disabled						= "DISABLED!";
Lootomatic.Strings.MEnabled						= "Enabled";
Lootomatic.Strings.MDisabled					= "Enable";

Lootomatic.Strings.Roll							= "Roll";
Lootomatic.Strings.AutoLoot						= "AutoLoot";
Lootomatic.Strings.AutoPass						= "AutoPass";
Lootomatic.Strings.AutoGreed					= "AutoGreed";
Lootomatic.Strings.RollMessages					= "Rollresults";
Lootomatic.Strings.NoBoss						= "No Bosses";

Lootomatic.Strings.Never						= "Never";
Lootomatic.Strings.White						= "Common";



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the settingsframe ----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Settings						= "Settings";

Lootomatic.Strings.Settings_BootyHeader			= "Lootfenster";
Lootomatic.Strings.Settings_BootyQuest			= "Don't loot Questitems";
Lootomatic.Strings.Settings_BootyMove			= "Follow mousecursor";
Lootomatic.Strings.Settings_BootyClose			= "Close after looting";

Lootomatic.Strings.Settings_RollHeader			= "Rollingframe";
Lootomatic.Strings.Settings_RollTooltips		= "Display long tooltip";
Lootomatic.Strings.Settings_RollQuest			= "Don't roll on Questitems";
Lootomatic.Strings.Settings_RollPosition		= "Move";
Lootomatic.Strings.Settings_RollPositionSave	= "Save";
Lootomatic.Strings.Settings_RollPositionCancel	= "Cancel";
Lootomatic.Strings.Settings_RollPositionOkay	= "Okay";
Lootomatic.Strings.Settings_RollPositionReset	= "Reset";
Lootomatic.Strings.Settings_RollPositionTimer	= "Delay";
Lootomatic.Strings.Settings_RollPositionTimerNo	= "No Delay";

Lootomatic.Strings.Settings_DropHeader			= "Drop Items";
Lootomatic.Strings.Settings_DropQuest			= "Always confirm Questitems";
Lootomatic.Strings.Settings_DropConfirmNo		= "No confirmation when dropping";
Lootomatic.Strings.Settings_DropConfirm			= "Confirm for <NUM> or more Items";
Lootomatic.Strings.Settings_DropAmmo			= "<NUM> Ammunition = 1 Item";
Lootomatic.Strings.Settings_DropTimeoutNo		= "No automatic selection";
Lootomatic.Strings.Settings_DropTimeout			= "after <NUM> seconds:";

Lootomatic.Strings.Settings_ChatHeader			= "Chatframe";
Lootomatic.Strings.Settings_ChatOutput			= "Display Lootmessages in Chat";
Lootomatic.Strings.Settings_RollNewStyle		= "Rollresults in Lootomatic-Style";

Lootomatic.Strings.Settings_MixedHeader			= "Mixed";
Lootomatic.Strings.Settings_MixedListFilter		= "Items for all Chars?";
Lootomatic.Strings.Settings_MixedBackUp			= "AutoBackup create";
Lootomatic.Strings.Settings_MixedCreateBackUp	= "Create Backup now";
Lootomatic.Strings.Settings_MixedClearBackUp	= "Clear Backup";
----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the itemfilter -------------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.ItemFilter					= "ItemFilter";
Lootomatic.Strings.Itemname						= "Itemname";
Lootomatic.Strings.Looting						= "Looting";
Lootomatic.Strings.Rolling						= "Rolling";

Lootomatic.Strings.LootStatus					= { "","Don't loot","Loot","Drop" };
Lootomatic.Strings.RollStatus					= { "","Pass","Greed","Need","Manual" };



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in tooltips -------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Tooltip_LongText = "\nHold the shift-key, to display the long description.";
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ItemAdd =
	{
	"Add Entry",
	"|cff00c0f3Leftclick:|r Adds the entry to the global ItemFilter.\n|cff00c0f3Rightclick:|r Adds the entry to the character's ItemFilter.",
	"\nAt least the itemname and either Looting- or Rollingbehaviour are necessary to add an entry.\n\nEvery Itemname can only be added once to the global and once to the character's ItemFilter",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ItemRemove =
	{
	"Remove Entry",
	"Removes the currently selected entry from the list.",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Itemname =
	{
	"Itemname",
	"Name of the Item, that should be added to the list.",
	"\nYou can use the character * as a wildcard.\n\nCan be filled by dragging an item into the field, or by shift-clicking an item in your bag as long as the window of the itemfilter is visible.",
	"\nYou can use the following keywords too:",
	{"|cffffffaa$"..Lootomatic.Keywords.quest.."\n$"..Lootomatic.Keywords.ammo.."\n$"..Lootomatic.Keywords.craft.."\n$"..Lootomatic.Keywords.rune.."#|r","Questitems\nevery type of ammunition\nCrafting Runes\nRunes with the Tier # (i.e. $"..Lootomatic.Keywords.rune.."1)"},
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Looting =
	{
	"Lootbehaviour",
	"Behaviour, when a Bootywindow is opened.",
	"\nWith the option \"Drop\" the item will be looted first and after that every item in your bag with the identical name will be thrown into the trashbin. If these are more than five items, you have to confirm this action.\nBe careful, when you use this option, as the author won't take responsibility, if you throw away some of your items by mistake!",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Rolling =
	{
	"Rollingbehaviour",
	"Behaviour, when a rollframe is being displayed.",
	"\nWith the option \"Manual\" the item won't be rolled automatically, even if that would happen due to the selected rarity.",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ResizeButton =
	{
	"Resize window",
	"Click and drag to resize the window.",
	};
