---------------------------------------------------------------------------------------------------------
-- Lootomatic - Locales for ENGLISH Clients
--
-- written by PetraAreon
-- released under the Creative Commons License By-Nc-Sa: http://creativecommons.org/licenses/by-nc-sa/3.0/
--
-- Get the current version at:   http://rom.curse.com/downloads/rom-addons/details/lootomatic.aspx
----------------------------------------------------------------------------------------------------------
-- Information for translators:
--
--   modified line 42 (RollFrameSave)
--     Changed "Ctrl+Shift+Click" to "Shift+Click"; was too complicated to handle
--   added lines 47-50 (Removed1, Removed2, NotFound1, NotFound2)
--     these contain systemmessages, when an item has been removed from the itemfilter via the DropTab
--   added line 105 (Settings_RollNewStyle)
--     new option in the settingsframe, to write rollresults in lootomatic-style (item - player - result)
--   restructured the syntax of the locales, makes it easier to replace missing strings with fallback
----------------------------------------------------------------------------------------------------------


----------------------------------------------------------------------------------------------------------
---------- Keywords, that can be used in the itemfilter --------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Keywords.none  = "nic";
Lootomatic.Keywords.quest = "misja";
Lootomatic.Keywords.craft = "rzemiosło";
Lootomatic.Keywords.rune  = "runa"; -- Grade of rune gets appended! i.e. "rune1"
Lootomatic.Keywords.ammo  = "amunicja";



----------------------------------------------------------------------------------------------------------
---------- Strings that are written in the chatframe -----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Loaded						= "załadowany, wpisz \"|cffFFFE80/lootomatic|r\" lub użyj przycisku na mini mapie, aby otworzyć ustawienia.";
Lootomatic.Strings.Updated						= "Wykryto nową wersję <VERSION>, proszę sprawdzić ustawienia ( stracisz spolszczenie ).";
Lootomatic.Strings.RollChange					= "Ustawienia losowania zmienione na <ROLLSETTING>!";
Lootomatic.Strings.Description					= "Addon umożliwiający natychmiastowe podniesienie wszystkich przemiotów z martwego przeciwnika. Może też automatycznie za Ciebie klikać potrzebę, chciwość lub pasować, zależnie jak ustawisz jego reakcję na dany przedmiot.";
Lootomatic.Strings.AddFilter					= "Dodaj filtr do przedmiotu";
Lootomatic.Strings.AddQuickFilter1				= "Sposób losowania dla przedmiotu |cffFFFE80\"<ITEM>\"|r został ustawiony na |cffFFFE80\"<ROLL>\"|r do globalnych danych.";
Lootomatic.Strings.AddQuickFilter2				= "Sposób losowania dla przedmiotu |cffFFFE80\"<ITEM>\"|r został ustawiony na |cffFFFE80\"<ROLL>\"|r do danych postaci.";
Lootomatic.Strings.RollFrameSave				= "\n|cff00c0f3Kliknij+Ctrl|r, aby zapisać zachowanie w globalnych danych.\n|cff00c0f3Kliknij+Shift|r, aby zapisać w danych postaci.";
Lootomatic.Strings.DropTab1						= "Okienko filtrów";
Lootomatic.Strings.DropTab2						= "Przeciągnij przedmiot z plecaka do wybranych filtrów np. pasuj, a jeśli sam zbierzesz - wyrzuć. LPM dodajesz filtr do globalnych danych, PPM do danych postaci.";
Lootomatic.Strings.Added1						= "Przedmiot \"<ITEM>\" został dodany do globalnych danych z ustawieniami <SETTINGS>.";
Lootomatic.Strings.Added2						= "Przedmiot \"<ITEM>\" został dodany do danych postaci z ustawieniami <SETTINGS>.";
Lootomatic.Strings.Removed1						= "Przedmiot \"<ITEM>\" został usunięty z globalnych danych.";
Lootomatic.Strings.Removed2						= "Przedmiot \"<ITEM>\" został usunięty z danych postaci.";
Lootomatic.Strings.NotFound1					= "Przedmiot \"<ITEM>\" nie został znaleziony w globalnych danych.";
Lootomatic.Strings.NotFound2					= "Przedmiot \"<ITEM>\" nie został znaleziony w danych postaci.";



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the minimap menue ----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Enabled						= "ON!";
Lootomatic.Strings.Disabled						= "OFF!";
Lootomatic.Strings.MEnabled						= "Włączony";
Lootomatic.Strings.MDisabled					= "Wyłączony";

Lootomatic.Strings.Roll							= "Podział łupu";
Lootomatic.Strings.AutoLoot						= "Autozbieranie";
Lootomatic.Strings.AutoPass						= "AutoPasowanie";
Lootomatic.Strings.AutoGreed					= "AutoChciwość";
Lootomatic.Strings.RollMessages					= "Wiadomości o wynikach losowania";
Lootomatic.Strings.NoBoss						= "Oprócz bossów";

Lootomatic.Strings.Never						= "Nigdy";
Lootomatic.Strings.White						= "Zwykłe";



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the settingsframe ----------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Settings						= "Ustawienia";

Lootomatic.Strings.Settings_BootyHeader			= "Okno zbierania";
Lootomatic.Strings.Settings_BootyQuest			= "Nie zbieraj przedmiotów misji";
Lootomatic.Strings.Settings_BootyMove			= "Podążaj za kursorem";
Lootomatic.Strings.Settings_BootyClose			= "Zamknij po zbieraniu";

Lootomatic.Strings.Settings_RollHeader			= "Losowanie";
Lootomatic.Strings.Settings_RollTooltips		= "Pokaż długie wskazówki";
Lootomatic.Strings.Settings_RollQuest			= "Nie losuj przedmiotów misji";
Lootomatic.Strings.Settings_RollPosition		= "Przesuń";
Lootomatic.Strings.Settings_RollPositionSave	= "Zapisz";
Lootomatic.Strings.Settings_RollPositionCancel	= "Anuluj";
Lootomatic.Strings.Settings_RollPositionOkay	= "OK";
Lootomatic.Strings.Settings_RollPositionReset	= "Reset";
Lootomatic.Strings.Settings_RollPositionTimer	= "Opóźnienie";
Lootomatic.Strings.Settings_RollPositionTimerNo	= "Bez opóźnienia";

Lootomatic.Strings.Settings_DropHeader			= "Wyrzucanie";
Lootomatic.Strings.Settings_DropQuest			= "Zawsze potwierdzaj przedmioty misji";
Lootomatic.Strings.Settings_DropConfirmNo		= "Nie potwierdzaj, kiedy wyrzucasz";
Lootomatic.Strings.Settings_DropConfirm			= "Potwierdzaj przy <NUM> lub większej ilości itemów";
Lootomatic.Strings.Settings_DropAmmo			= "Traktuj <NUM> amunicji jako 1 item ";
Lootomatic.Strings.Settings_DropTimeoutNo		= "Nie wyrzucaj automatycznie";
Lootomatic.Strings.Settings_DropTimeout			= "Po <NUM> sekundach:";

Lootomatic.Strings.Settings_ChatHeader			= "Chat";
Lootomatic.Strings.Settings_ChatOutput			= "Pokazuj wiadomości o zbieraniu";
Lootomatic.Strings.Settings_RollNewStyle		= "Wyniki losowania w Stylu Lootomatic";

Lootomatic.Strings.Settings_MixedHeader			= "Mieszane";
Lootomatic.Strings.Settings_MixedListFilter		= "Elementy wszystkie znaki?";
Lootomatic.Strings.Settings_MixedBackUp			= "Automatyczne tworzenie kopii zapasowych";



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in the itemfilter -------------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.ItemFilter					= "Filtry przedmiotów";
Lootomatic.Strings.Itemname						= "Nazwa przedmiotu";
Lootomatic.Strings.Looting						= "Zbieranie";
Lootomatic.Strings.Rolling						= "Losowanie";

Lootomatic.Strings.LootStatus					= { "","Nie zbieraj","Zbieraj","Wyrzucaj" };
Lootomatic.Strings.RollStatus					= { "","Pasuj","Chciwość","Potrzeba","Ręcznie" };



----------------------------------------------------------------------------------------------------------
---------- Strings that are used in tooltips -------------------------------------------------------------
----------------------------------------------------------------------------------------------------------
Lootomatic.Strings.Tooltip_LongText = "\nPrzytrzymaj Shift, aby zobaczyć więcej.";
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ItemAdd =
	{
	"Dodaj",
	"|cff00c0f3LPM:|r Dodaj do globalnych danych.\n|cff00c0f3PPM:|r Dodaj do danych postaci.",
	"\nKażdy przedmiot jest dodawany osobno do danych postaci i globalnych.",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ItemRemove =
	{
	"Usuń",
	"Usuń zaznaczony wpis z listy.",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Itemname =
	{
	"Nazwa przedmiotu",
	"Nazwa przedmiotu, którą chcesz dodać do listy.",
	"\nMożesz wpisać * przed lub po przedmiocie, aby dodać wszystkie itemy tego typu np. Hełm *\n\nMożesz również dodać przedmiot do filtrów przeciągając go w plecaka na ikonkę plecaka.",
	"\nMożesz użyć następujących filtrów:",
	{"|cffffffaa$"..Lootomatic.Keywords.quest.."\n$"..Lootomatic.Keywords.ammo.."\n$"..Lootomatic.Keywords.craft.."\n$"..Lootomatic.Keywords.rune.."#|r","Przedmioty do misji\nKażdy typ amunicji\nRuny Produkcyjne\nRuny z tierem # ( np. $"..Lootomatic.Keywords.rune.."1)"},
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Looting =
	{
	"Autozbieranie",
	"Zbieraj / nie zbieraj / wyrzucaj.",
	"\nOpcja wyrzucaj, najpierw podnosi przedmiot, a potem go wyrzuca - usprawnia to szybkie zbieranie całego dropu ( nie musisz zamykać okienka z łupem, ponieważ wszystko zostanie zebrane ).",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_Rolling =
	{
	"Autolosowanie",
	"Pasowanie / Chciwość / Potrzeba / Ręczne.",
	"\nDzięki opcji Ręczne możesz sam losować.",
	};
Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ResizeButton =
	{
	"Zmień rozmiar okna",
	"Naciśnij i przesuń, aby zmienić rozmiar okna.",
	};
