----------------------------------------------------------------------------------------------------------
-- Lootomatic
--
-- written by PetraAreon, KingDefrost
-- released under the Creative Commons License By-Nc-Sa: http://creativecommons.org/licenses/by-nc-sa/3.0/
--
-- Get the current version at:   http://rom.curse.com/downloads/rom-addons/details/lootomatic.aspx
----------------------------------------------------------------------------------------------------------

local Sol = LibStub("Sol");

Lootomatic.Playerbuffer= UnitName("player");

Lootomatic.Data =
	{
	Loaded          = false,
	Name            = "Lootomatic",
	Version         = "v1.40",
	Language        = nil,
	MissingLang     = nil,
	Resizing        = false,
	ListSelect      = nil,
	BootyCloseTimer = nil,
	StringSwitch    = false,
	Fade            = {},
	GarbageTimer    = false,
	GarbageArray    = {},
	RollFrameTimers = {},
	RollresultHack  = nil,
	};

Lootomatic.Defaults =
	{
	AM              = true,	-- Enabled in AddonManager?
	Enabled         = true,	-- Lootomatic enabled?
	Roll            = 3,
	LootMaster      = false,
	AutoLoot        = 3,
	AutoPass        = 1,
	AutoGreed       = 1,
	AutoLootBoss    = false,

	ItemFilterX     = 450,
	ItemFilterY     = 300,
	ItemFilter      = {},

	LootQuest       = true,
	LootMove        = false,
	LootClose       = false,

	RollQuest       = true,
	RollTooltip     = true,
	RollDelay       = 2,
	RollFrameX      = 0,
	RollFrameY      = -60,
	RollFrameD      = -64,

	DropQuest       = true,
	DropItems       = 5,
	DropAmmo        = 20,
	DropTime        = 10,
	DropAuto        = false,
	DropBugFix      = false,

	ChatOutput      = false,
	RollNewStyle    = true,
	
	ListFilter		= false,
	BackUp			= false,
	
	RollResults     = {{true,true,true},{true,true,true},{true,true,true},{true,true,true},{true,true,true},{true,true,true},},
	ChatFrames      = {true,true,true,true,true,true,true,true,true,true},
	ChatColor       = {r=1,g=1,b=0.5},
	};

local temp=string.gsub(TEXT('SYS_LOOT_MASTER_LOOTER'),"%[%%s%]","");
Lootomatic.BlockMessages =
	{
	"^"..TEXT('SYS_LOOT_ALTERNATE').."$",
	"^"..TEXT('SYS_LOOT_FREEFORALL').."$",
	"^"..temp,
	};

Lootomatic.ItemTypeData = {};
Lootomatic.DataMirror = {};
Lootomatic.Func = {};

function Lootomatic.Func.OnEvent(event)
	if (event == "LOADING_END" and not Lootomatic.Data.Loaded) then
		Lootomatic.Data.Language = string.upper(string.sub(GetLanguage(),1,2));

		local func, err = loadfile("Interface/Addons/Lootomatic/Locales/"..Lootomatic.Data.Language..".lua");
		if (err) then
			Lootomatic.Data.MissingLang = Lootomatic.Language;
			Lootomatic.Data.Language    = "EN";
		end;

		-- Load Locales, English first, Localized afterwards to prevent missing entries
		Lootomatic.Keywords = {};
		Lootomatic.Strings  = {};
		dofile("Interface/Addons/Lootomatic/Locales/EN.lua");
		dofile("Interface/Addons/Lootomatic/Locales/"..Lootomatic.Data.Language..".lua");


		Lootomatic.QualityColors =
			{
			"ffffff",
			"00ff00",
			"0072bc",
			"c805f8",
			"f68e56",
			"a37d50",
			};

		Lootomatic.ListEntries =
			{
			[0]   = "|cffff8000"                       ..LOOT_MASTER_LOOTER.."|r",
			[1]   = "|cffaaaaaa"                       ..tostring(Lootomatic.Strings.Never).."|r",
			[2]   = "|cff"..Lootomatic.QualityColors[1]..tostring(Lootomatic.Strings.White).."|r",
			[3]   = "|cff"..Lootomatic.QualityColors[2]..ITEM_QUALITY1_DESC.."|r",
			[4]   = "|cff"..Lootomatic.QualityColors[3]..ITEM_QUALITY2_DESC.."|r",
			[5]   = "|cff"..Lootomatic.QualityColors[4]..ITEM_QUALITY3_DESC.."|r",
			[6]   = "|cff"..Lootomatic.QualityColors[5]..ITEM_QUALITY4_DESC.."|r",
			[7]   = "|cff"..Lootomatic.QualityColors[6]..ITEM_QUALITY5_DESC.."|r",
			[101] = "|cffff0000"..LOOT_FREE_FOR_ALL.."|r",
			};

		Lootomatic.Rolls =
			{
			[1] = TEXT('SYS_GIVE_UP'),
			[2] = TEXT('SYS_GREED'),
			[3] = TEXT('SYS_NEED'),
			};

		if (string.find(TEXT('SYS_GIVE_ITEM'),"<ITEM>")==nil) then
			Lootomatic.Data.StringSwitch=true;
		end;

		if (Lootomatic_Settings == nil or table.maxn(Lootomatic_Settings.ItemFilter) < 2) then
			if(Lootomatic_Settings_Backup == nil)then
				if (Lootomatic_Settings == nil)then
						Lootomatic_Settings = Lootomatic.Defaults;
				end
			else
				
				local Transfer_Lootomatic_Settings_Backup = Lootomatic_Settings_Backup;--Restore from Backup
				Lootomatic_Settings = Lootomatic.Defaults;
				
				for i,v in pairs(Lootomatic_Settings_Backup) do
					if (type(Lootomatic_Settings[i]) == type(Transfer_Lootomatic_Settings_Backup[i])) then
						Lootomatic_Settings[i] = Transfer_Lootomatic_Settings_Backup[i];
					end;
				end;
			end
		else
			
		if(Lootomatic_Settings.BackUp == true)then--Switch Backup on/off --Create Backup
			if(Lootomatic_Settings_Backup == nil)then
				Lootomatic_Settings_Backup = Lootomatic.Defaults;
			end
			local Transfer_Lootomatic_Settings = Lootomatic_Settings;

			for i,v in pairs(Lootomatic_Settings) do
				if (type(Lootomatic_Settings_Backup[i]) == type(Transfer_Lootomatic_Settings[i])) then
					Lootomatic_Settings_Backup[i] = Transfer_Lootomatic_Settings[i];
				end;
			end;
		end
			
			if (Lootomatic.Data.Version ~= Lootomatic_Settings.Version) then -- When detecting different version, first set to defaults and then try to import old settings
				local Transfer_Lootomatic_Settings = Lootomatic_Settings;
				Lootomatic_Settings = Lootomatic.Defaults;

				for i,v in pairs(Lootomatic_Settings) do
					if (type(Lootomatic_Settings[i]) == type(Transfer_Lootomatic_Settings[i])) then
						Lootomatic_Settings[i] = Transfer_Lootomatic_Settings[i];
					end;
				end;

				Lootomatic.Func.AddChatMessage(string.gsub(tostring(Lootomatic.Strings.Updated),"<VERSION>",Lootomatic.Data.Version));
			end;
		end;
		Lootomatic_Settings.Version = Lootomatic.Data.Version;
		
		--[[{
			Name = name,
			Loot = 1,
			Roll = rollmode,
			Char = UnitName("player"),
			}
			]]--
		--Mirrior Datas increase speed
		local Transfer_Lootomatic_Items = Lootomatic_Settings.ItemFilter;

			for i,v in pairs(Lootomatic_Settings.ItemFilter) do
				if (type(Lootomatic_Settings.ItemFilter[i]) == type(Transfer_Lootomatic_Items[i])) then
						if(Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name] ~= nil)then
							if(Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name].Char == nil)then
								Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name] = Transfer_Lootomatic_Items[i];
								Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name].Index = i;
							
							else
								if(Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name].Char == UnitName("player") )then
									Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name] = Transfer_Lootomatic_Items[i];
									Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name].Index = i;
								
								end;
							
							end;
						else
							Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name] = Transfer_Lootomatic_Items[i];
							Lootomatic.DataMirror[Transfer_Lootomatic_Items[i].Name].Index = i;
						end;
				end;
			end;
		
		if (AddonConfig) then
			local AddonConfigTable =
				{
				name = Lootomatic.Data.Name,
				buttonTitle = Lootomatic.Data.Name,
				configFrame = Lootomatic_AddonConfigFrame,
				version = Lootomatic.Data.Version,
				author = "PetraAreon & KingDefrost",
 				fnDefault = Lootomatic_AddonConfig_Defaults,
 				fnReadSettings = Lootomatic_AddonConfig_ReadSettings,
 				fnApply = Lootomatic_AddonConfig_Apply,
				}

			AddonConfig.RegisterConfigTable(AddonConfigTable);
		end

		if (AddonManager) then
			local addon =
				{
				name = "|cffFFFE80Lootomatic|r",
				version = "|cffFFFFB2"..Lootomatic.Data.Version.."|r",
				author = "PetraAreon & KingDefrost",
				description = tostring(Lootomatic.Strings.Description),
				icon = "Interface/Addons/Lootomatic/Textures/minimap-normal.tga",
				category = "Inventory",
				configFrame = Lootomatic_SettingsFrame,
				disableScript = function() Lootomatic_Settings.AM = false; Lootomatic_Minimap:Hide(); end,
				enableScript = function() Lootomatic_Settings.AM = true; Lootomatic_Minimap:Show(); end,
				};

			if (AddonManager.RegisterAddonTable) then
				AddonManager.RegisterAddonTable(addon);
			else
				AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommands, addon.miniButton, addon.version, addon.author);
			end;
		else
			Lootomatic.Func.AddChatMessage(tostring(Lootomatic.Strings.Loaded));
		end;

		if (Lootomatic.Data.MissingLang ~= nil) then
			Lootomatic.Func.AddChatMessage("No locales found for your language \""..Lootomatic.Data.MissingLang.."\", switching to fallback \"EN\". If you want your language to be added, please contact the author PetraAreon via CurseForge ;-)");
		end;

		StaticPopupDialogs["LOOTOMATIC_DELETE_ITEMS"] = {
			text = DELETE_GARBAGE_ITEM,
			button1 = TEXT("YES"),
			button2 = TEXT("NO"),
			whileDead = 1,
			exclusive = 1,
			showAlert = 1,
			hideOnEscape = 1,
			timeout = Lootomatic_Settings.DropTime,
			OnShow = function(this)
				this:SetAlpha(0.8);
				getglobal(this:GetName().."Text"):SetText(getglobal(this:GetName().."Text"):GetText().."|cffffffff\n");
				local Summary={};
				for n=1,table.maxn(Lootomatic.GarbageArray) do
					local id, icon, name, count = GetBagItemInfo(Lootomatic.GarbageArray[n][1]);
					local found=false;

					for i=1,table.maxn(Summary) do
						if (Summary[i]["name"]==name) then
							Summary[i]["count"] = Summary[i]["count"]+count;
							found=true;
							break;
						end;
					end;
					if (not found) then
						table.insert(Summary,{["name"] = name, ["count"] = count});
					end;
				end;

				for n=1,table.maxn(Summary) do
					getglobal(this:GetName().."Text"):SetText(getglobal(this:GetName().."Text"):GetText().."\n"..Summary[n]["count"].."x "..Summary[n]["name"]);
				end;

				getglobal(this:GetName().."Text"):SetText(getglobal(this:GetName().."Text"):GetText().."|r");

				StaticPopup_Resize(this,"LOOTOMATIC_DELETE_ITEMS");
			end,
			OnHide = function(this)
				if (this.timeleft==0 and Lootomatic_Settings.DropTime~=0 and Lootomatic_Settings.DropAuto==true) then
					Lootomatic.Func.DropGarbage();
				end;
				this:SetAlpha(1);
			end,
			OnAccept = function ()
				Lootomatic.Func.DropGarbage();
			end,
			OnUpdate = function(this, elapsedTime)
				if (Lootomatic_Settings.DropTime~=0) then
					if (Lootomatic_Settings.DropAuto==true) then
						getglobal(this:GetName().."Button1"):SetText(TEXT("YES").." ("..string.format("%.0f",math.ceil(this.timeleft))..")");
						getglobal(this:GetName().."Button2"):SetText(TEXT("NO" ));
					else
						getglobal(this:GetName().."Button1"):SetText(TEXT("YES"));
						getglobal(this:GetName().."Button2"):SetText(TEXT("NO" ).." ("..string.format("%.0f",math.ceil(this.timeleft))..")");
					end;
				end;
			end,
		};

		local width=0;
		for n=1,6 do
			local item=getglobal("Lootomatic_RollresultSettings_Text"..n);
			item:ClearAllAnchors();
			item:SetAnchor("TOPLEFT","TOPLEFT",DropDownList2,15,(n*UIDROPDOWNMENU_BUTTON_HEIGHT) + UIDROPDOWNMENU_BORDER_HEIGHT + 5);
			item:SetText(Lootomatic.ListEntries[n+1]);

			Lootomatic_SettingsFrame_Rollframe_Position:SetText(Lootomatic.ListEntries[n+1]);
			local itemwidth = Lootomatic_SettingsFrame_Rollframe_Position:GetTextWidth();
			if (itemwidth>width) then
				width = itemwidth;
			end;
		end;
		for n=1,3 do
			local item=getglobal("Lootomatic_RollresultSettings_Icon"..n);
			item:ClearAllAnchors();
			item:SetAnchor("TOPLEFT","TOPLEFT",DropDownList2,25+width+25*(n-1),10);
			Lootomatic_RollresultSettings.width = width + 80;
		end;
		for n=1,6 do
			for i=1,3 do
				local item=getglobal("Lootomatic_RollresultSettings_Button"..n..i);
				item:ClearAllAnchors();
				item:SetAnchor("TOPLEFT","TOPLEFT",DropDownList2,25+width+25*(i-1),(n*UIDROPDOWNMENU_BUTTON_HEIGHT) + UIDROPDOWNMENU_BORDER_HEIGHT );
			end;
		end;



		Lootomatic_ItemFilterFrame:ClearAllAnchors();
		Lootomatic_ItemFilterFrame:SetAnchor("TOPLEFT","CENTER",UIParent,-Lootomatic_Settings.ItemFilterX/2,-Lootomatic_Settings.ItemFilterY/2);
		Lootomatic_ItemFilterFrame:SetSize(Lootomatic_Settings.ItemFilterX,Lootomatic_Settings.ItemFilterY);

		Lootomatic_ItemFilterFrame_Header                      :SetText(Lootomatic.Data.Name.." - "..tostring(Lootomatic.Strings.ItemFilter));
		Lootomatic_ItemFilterFrame_Itemname_Title              :SetText(tostring(Lootomatic.Strings.Itemname));
		Lootomatic_ItemFilterFrame_Looting_Title               :SetText(tostring(Lootomatic.Strings.Looting));
		Lootomatic_ItemFilterFrame_Rolling_Title               :SetText(tostring(Lootomatic.Strings.Rolling));

		Lootomatic_SettingsFrame_Header                        :SetText(Lootomatic.Data.Name.." - "..tostring(Lootomatic.Strings.Settings));

		Lootomatic_SettingsFrame_BootyFrame_Header_Text        :SetText(tostring(Lootomatic.Strings.Settings_BootyHeader));
		Lootomatic_SettingsFrame_BootyFrame_Quest_Text         :SetText(tostring(Lootomatic.Strings.Settings_BootyQuest));
		Lootomatic_SettingsFrame_BootyFrame_Move_Text          :SetText(tostring(Lootomatic.Strings.Settings_BootyMove));
		Lootomatic_SettingsFrame_BootyFrame_Close_Text         :SetText(tostring(Lootomatic.Strings.Settings_BootyClose));

		Lootomatic_SettingsFrame_Rollframe_Header_Text         :SetText(tostring(Lootomatic.Strings.Settings_RollHeader));
		Lootomatic_SettingsFrame_Rollframe_Quest_Text          :SetText(tostring(Lootomatic.Strings.Settings_RollQuest));
		Lootomatic_SettingsFrame_Rollframe_RollTooltip_Text    :SetText(tostring(Lootomatic.Strings.Settings_RollTooltips));
		Lootomatic_SettingsFrame_Rollframe_Position            :SetText(tostring(Lootomatic.Strings.Settings_RollPosition));
		Lootomatic_SettingsFrame_Rollframe_PositionSave        :SetText(tostring(Lootomatic.Strings.Settings_RollPositionSave));
		Lootomatic_SettingsFrame_Rollframe_PositionCancel      :SetText(tostring(Lootomatic.Strings.Settings_RollPositionCancel));
		
		Lootomatic_SettingsFrame_Mixed_Header_Text				:SetText(tostring(Lootomatic.Strings.Settings_MixedHeader));
		Lootomatic_SettingsFrame_Mixed_ListFilter_Text			:SetText(tostring(Lootomatic.Strings.Settings_MixedListFilter));
		Lootomatic_SettingsFrame_Mixed_BackUp_Text				:SetText(tostring(Lootomatic.Strings.Settings_MixedBackUp));
		Lootomatic_SettingsFrame_Mixed_ClearBackUp				:SetText(tostring(Lootomatic.Strings.Settings_MixedClearBackUp));
		Lootomatic_SettingsFrame_Mixed_CreateBackUp				:SetText(tostring(Lootomatic.Strings.Settings_MixedCreateBackUp));
		
		Lootomatic_SettingsFrame_DropItems_Header_Text         :SetText(tostring(Lootomatic.Strings.Settings_DropHeader));
		Lootomatic_SettingsFrame_DropItems_DropQuest_Text      :SetText(tostring(Lootomatic.Strings.Settings_DropQuest));

		Lootomatic_SettingsFrame_Chatframe_Header_Text         :SetText(tostring(Lootomatic.Strings.Settings_ChatHeader));
		Lootomatic_SettingsFrame_Chatframe_ChatOutput_Text     :SetText(tostring(Lootomatic.Strings.Settings_ChatOutput));
		Lootomatic_SettingsFrame_Chatframe_RollNewStyle_Text   :SetText(tostring(Lootomatic.Strings.Settings_RollNewStyle));

		Lootomatic_AddonConfigFrame_BootyFrame_Header_Text     :SetText(tostring(Lootomatic.Strings.Settings_BootyHeader));
		Lootomatic_AddonConfigFrame_BootyFrame_Quest_Text      :SetText(tostring(Lootomatic.Strings.Settings_BootyQuest));
		Lootomatic_AddonConfigFrame_BootyFrame_Move_Text       :SetText(tostring(Lootomatic.Strings.Settings_BootyMove));
		Lootomatic_AddonConfigFrame_BootyFrame_Close_Text      :SetText(tostring(Lootomatic.Strings.Settings_BootyClose));

		Lootomatic_AddonConfigFrame_Rollframe_Header_Text      :SetText(tostring(Lootomatic.Strings.Settings_RollHeader));
		Lootomatic_AddonConfigFrame_Rollframe_Quest_Text       :SetText(tostring(Lootomatic.Strings.Settings_RollQuest));
		Lootomatic_AddonConfigFrame_Rollframe_RollTooltip_Text :SetText(tostring(Lootomatic.Strings.Settings_RollTooltips));
		Lootomatic_AddonConfigFrame_Rollframe_Position         :SetText(tostring(Lootomatic.Strings.Settings_RollPosition));
		Lootomatic_AddonConfigFrame_Rollframe_PositionSave     :SetText(tostring(Lootomatic.Strings.Settings_RollPositionSave));
		Lootomatic_AddonConfigFrame_Rollframe_PositionCancel   :SetText(tostring(Lootomatic.Strings.Settings_RollPositionCancel));

		Lootomatic_AddonConfigFrame_DropItems_Header_Text      :SetText(tostring(Lootomatic.Strings.Settings_DropHeader));
		Lootomatic_AddonConfigFrame_DropItems_DropQuest_Text   :SetText(tostring(Lootomatic.Strings.Settings_DropQuest));

		Lootomatic_AddonConfigFrame_Chatframe_Header_Text      :SetText(tostring(Lootomatic.Strings.Settings_ChatHeader));
		Lootomatic_AddonConfigFrame_Chatframe_ChatOutput_Text  :SetText(tostring(Lootomatic.Strings.Settings_ChatOutput));
		Lootomatic_AddonConfigFrame_Chatframe_RollNewStyle_Text:SetText(tostring(Lootomatic.Strings.Settings_RollNewStyle));
		
		Lootomatic_AddonConfigFrame_Mixed_Header_Text			:SetText(tostring(Lootomatic.Strings.Settings_MixedHeader));
		Lootomatic_AddonConfigFrame_Mixed_ListFilter_Text		:SetText(tostring(Lootomatic.Strings.Settings_MixedListFilter));
		Lootomatic_AddonConfigFrame_Mixed_BackUp_Text			:SetText(tostring(Lootomatic.Strings.Settings_MixedBackUp));
		Lootomatic_AddonConfigFrame_Mixed_ClearBackUp			:SetText(tostring(Lootomatic.Strings.Settings_MixedClearBackUp));
		Lootomatic_AddonConfigFrame_Mixed_CreateBackUp			:SetText(tostring(Lootomatic.Strings.Settings_MixedCreateBackUp));
		
		Lootomatic_AddonConfigFrame_Credits_Text               :SetText(Lootomatic.Data.Name.." "..Lootomatic.Data.Version..", written by PetraAreon&KingDefrost");

		Lootomatic.Func.DropItems_DropAuto();

		Lootomatic_RollFrameGhosts_1                           :ClearAllAnchors();
		Lootomatic_RollFrameGhosts_1                           :SetAnchor("BOTTOM", "BOTTOM", UIParent, Lootomatic_Settings.RollFrameX, Lootomatic_Settings.RollFrameY);
		Lootomatic_RollFrameGhosts_1_Okay                      :SetText (tostring(Lootomatic.Strings.Settings_RollPositionOkay));
		Lootomatic_RollFrameGhosts_1_Reset                     :SetText (tostring(Lootomatic.Strings.Settings_RollPositionReset));
		Lootomatic_ClearBackup								   	=  (tostring(Lootomatic.Strings.ClearBackup));
		Lootomatic_CreateBackup								  	= (tostring(Lootomatic.Strings.CreateBackup));
		Lootomatic.Func.RollFrameGhosts_Move();

		Lootomatic_RollFrameGhosts_2:SetAlpha(0.4);
		Lootomatic_RollFrameGhosts_3:SetAlpha(0.4);
		Lootomatic_RollFrameGhosts_4:SetAlpha(0.4);
		Lootomatic_RollFrameGhosts_5:SetAlpha(0.4);
		Lootomatic_RollFrameGhosts_6:SetAlpha(0.4);

		GroupLootFrame1:ClearAllAnchors(); GroupLootFrame1:SetAnchor("CENTER","CENTER", Lootomatic_RollFrameGhosts_1, 0, 0);
		GroupLootFrame2:ClearAllAnchors(); GroupLootFrame2:SetAnchor("CENTER","CENTER", Lootomatic_RollFrameGhosts_2, 0, 0);
		GroupLootFrame3:ClearAllAnchors(); GroupLootFrame3:SetAnchor("CENTER","CENTER", Lootomatic_RollFrameGhosts_3, 0, 0);
		GroupLootFrame4:ClearAllAnchors(); GroupLootFrame4:SetAnchor("CENTER","CENTER", Lootomatic_RollFrameGhosts_4, 0, 0);
		GroupLootFrame5:ClearAllAnchors(); GroupLootFrame5:SetAnchor("CENTER","CENTER", Lootomatic_RollFrameGhosts_5, 0, 0);
		GroupLootFrame6:ClearAllAnchors(); GroupLootFrame6:SetAnchor("CENTER","CENTER", Lootomatic_RollFrameGhosts_6, 0, 0);

		Lootomatic_Dropdown:ClearAllAnchors();
		Lootomatic_Dropdown:SetAnchor("TOPRIGHT","TOPLEFT",Lootomatic_Minimap,0,0);

	 	UIDropDownMenu_Initialize   (Lootomatic_Dropdown               , Lootomatic.Func.MainMenue);
		UIDropDownMenu_Initialize   (Lootomatic_ChatFrameDropdown      , Lootomatic.Func.MainMenue, "MENU");
		UIDropDownMenu_Initialize   (Lootomatic_ItemFilterFrame_Looting, Lootomatic.Func.ItemFilter_LootmenuItems);
		UIDropDownMenu_SetSelectedID(Lootomatic_ItemFilterFrame_Looting, 1);
		UIDropDownMenu_Initialize   (Lootomatic_ItemFilterFrame_Rolling, Lootomatic.Func.ItemFilter_RollmenuItems);
		UIDropDownMenu_SetSelectedID(Lootomatic_ItemFilterFrame_Rolling, 1);

		-------------------------------------------------------------------------------------------------------------
		--                       !WARNING! Modifying Original Content                                              --
		-------------------------------------------------------------------------------------------------------------
		Sol.hooks.Hook(Lootomatic.Data.Name, "BagItemButton_OnClick",   Lootomatic.Func.BagItemButton_OnClick);    -- Add to ItemFilter by Shift-Clicking Items in Bag
		Sol.hooks.Hook(Lootomatic.Data.Name, "GroupLootFrame_OnShow",   Lootomatic.Func.GroupLootFrame_OnShow);    -- Add Lootomatic-Itemfilter line to item-rightclick in chatframe
		Sol.hooks.Hook(Lootomatic.Data.Name, "RollOnLoot",              Lootomatic.Func.RollOnLoot);               -- Add to ItemFilter by Ctrl-Clicking in Rollframe
		Sol.hooks.Hook(Lootomatic.Data.Name, "ChatFrame_OnEvent",       Lootomatic.Func.ChatFrame_OnEvent);        -- Filter Chatframe
		Sol.hooks.Hook(Lootomatic.Data.Name, "Hyperlink_Assign",        Lootomatic.Func.Hyperlink_Assign);         -- Add Lootomatic-Itemfilter line to item-rightclick in chatframe
		Sol.hooks.Hook(Lootomatic.Data.Name, "UIParent_OnEvent",        Lootomatic.Func.UIParent_OnEvent);         -- Replace Delete-Questitems Confirmationsdialogue
		Sol.hooks.Hook(Lootomatic.Data.Name, "ToggleDropDownMenu",      Lootomatic.Func.ToggleDropDownMenu);       -- Hack for additional display of Rollresultsettings
		Lootomatic.Data.GROUPLOOT_ROLL   = GROUPLOOT_ROLL;                                                         --
		Lootomatic.Data.GROUPLOOT_GREED  = GROUPLOOT_GREED;                                                        -- Storing original Tooltiptext for further processing
		Lootomatic.Data.GROUPLOOT_CANCEL = GROUPLOOT_CANCEL;                                                       --
		Lootomatic.Func.RollOnLoot_Tooltips();                                                                     -- Adding Lootomatic Textlines to the Tooltip of RollFrames
		-------------------------------------------------------------------------------------------------------------

		ACCS_AddChannelSetting(
			{
			Name		= Lootomatic.Data.Name,
			GetValue	= Lootomatic.Func.ACCS_GetChecked,
			SetValue	= Lootomatic.Func.ACCS_SetChecked,
			GetColor	= Lootomatic.Func.ACCS_GetColor,
			SetColor	= Lootomatic.Func.ACCS_SetColor,
			}
		);

		-- Exception for Addon yBag, which replaces the standard BagFrame
		if (type(yBag)=="table" and type(yBagItem1)=="table") then
			Lootomatic_DropTab:SetParent(yBag);
			Lootomatic_DropTab.Locations =
				{
				{"BOTTOMLEFT","BOTTOMRIGHT",Lootomatic_DropTab_Button,0,0},
				{"TOPLEFT","TOPRIGHT",Lootomatic_DropTab_Button,0,0},
				};

			Lootomatic_DropTab_Button:SetParent(yBag);
			Lootomatic_DropTab_Button:ClearAllAnchors();
			Lootomatic_DropTab_Button:SetAnchor("BOTTOMRIGHT","TOPLEFT",yBagItem1,0,0);

		-- Exception for Addon FlieBag, which does the same
		elseif (type(FlieBag)=="table" and type(FlieBagFrame)=="table") then
			Lootomatic_DropTab:SetParent(FlieBagFrame);
			Lootomatic_DropTab.Locations =
				{
				{"BOTTOMRIGHT","TOPRIGHT",FlieBagFrame,0,0},
				{"TOPRIGHT","TOPRIGHT",FlieBagFrame,0,26},
				};

			Lootomatic_DropTab_Button:SetParent(FlieBagFrame);
			Lootomatic_DropTab_Button:ClearAllAnchors();
			Lootomatic_DropTab_Button:SetAnchor("CENTER","CENTER",FlieBagFrameCloseButton,-60,1);

			FlieBagTitleText:ClearAllAnchors();
			FlieBagTitleText:SetAnchor("TOP","TOP",FlieBagFrame,-45,7); -- Move title a bit more left, to prevent hiding under button

		-- Exception for Addon CuteBag; Move Button a bit to the right, because there is no Button for BagSize
		elseif (type(CuteBag)=="table" and type(CuteBagFrame)=="table") then
			Lootomatic_DropTab:SetParent(BagFrame);
			Lootomatic_DropTab.Locations =
				{
				{"BOTTOMRIGHT","TOPRIGHT",BagFrame,0,0},
				{"TOPRIGHT","TOPRIGHT",BagFrame,0,26},
				};

			Lootomatic_DropTab_Button:ClearAllAnchors();
			Lootomatic_DropTab_Button:SetAnchor("CENTER","CENTER",BagFrameCloseButton,-27,1);

		-- Standardanchors for default-BagFrame
		else
			Lootomatic_DropTab:SetParent(BagFrame);
			Lootomatic_DropTab.Locations =
				{
				{"BOTTOMRIGHT","TOPRIGHT",BagFrame,0,0},
				{"TOPRIGHT","TOPRIGHT",BagFrame,0,26},
				};
		end;

		-- Anchors for Minimap-DropTab
		Lootomatic_MinimapDropTab.Locations =
				{
				{"TOPRIGHT","TOPLEFT",Lootomatic_Minimap,0,0},
				{"TOPLEFT","TOPRIGHT",Lootomatic_Minimap,0,0},
				{"BOTTOMRIGHT","BOTTOMLEFT",Lootomatic_Minimap,0,0},
				{"BOTTOMLEFT","BOTTOMRIGHT",Lootomatic_Minimap,0,0},
				};

		Lootomatic_CreditsGuild:SetText("[Nachtschw\195\164rmer]"); -- needed to change here, no ae possible in that damned xml

		SetBootFrameAutoTake(false); -- deactivate ingame-autolooting
		isAutoTakeBooty:Disable();   -- and disable the checkbutton

	 	SaveVariables("Lootomatic_Settings");
		SaveVariablesPerCharacter("Lootomatic_Settings_Backup");


		Lootomatic:RegisterEvent("BOOTY_SHOW");
		Lootomatic:RegisterEvent("CHAT_MSG_SYSTEM_GET");
 		Lootomatic.Data.Loaded = true;

	elseif (event == "BOOTY_SHOW") then
		if (Lootomatic_Settings.Enabled == true and (not AddonManager or Lootomatic_Settings.AM == true)) then
			if (Lootomatic_Settings.LootMove==true) then
				local x,y = GetCursorPos();
				BootyFrame:ClearAllAnchors();
				BootyFrame:SetAnchor("TOPLEFT", "TOPLEFT", UIParent, x/GetUIScale()-40, y/GetUIScale()-56);
			end;
			Lootomatic.Func.CheckBootyFrame();
		end;
	elseif (event == "CHAT_MSG_SYSTEM_GET") then
 		if (Lootomatic_Settings.Enabled == true and (not AddonManager or Lootomatic_Settings.AM == true)) then
 			if (Lootomatic_Settings.ChatOutput == true) then
				Lootomatic.Func.AddChatMessage(arg1);
 			end;

			if (Lootomatic.Data.StringSwitch) then
				Lootomatic.Data.GarbageTimer = 1;
			elseif (string.match(arg1,string.gsub(TEXT('SYS_GIVE_ITEM'),"<ITEM>","|H.*"))~=nil) then
				Lootomatic.Data.GarbageTimer = 1;
			end;
 		end;
	end;
end;




function Lootomatic.Func.OnUpdate(elapsedTime)
	if (Lootomatic.Data.Loaded) then
		Lootomatic.Func.FadeFrames(elapsedTime);

		if (Lootomatic.Data.Resizing) then
			Lootomatic.Func.ItemFilter_Repaint();
		end;

		if (Lootomatic_Settings.Enabled == true and (not AddonManager or Lootomatic_Settings.AM == true)) then
			if (type(Lootomatic.Data.GarbageTimer)=="number") then
				Lootomatic.Data.GarbageTimer = Lootomatic.Data.GarbageTimer - elapsedTime;
				if (Lootomatic.Data.GarbageTimer <= 0) then
					Lootomatic.Func.SearchGarbage();
					Lootomatic.Data.GarbageTimer = false;
				end;
			end;

			if (Lootomatic.Data.BootyCloseTimer ~= nil) then
				if (GetTickCount()-Lootomatic.Data.BootyCloseTimer>500) then BootyFrame:Hide(); Lootomatic.Data.BootyCloseTimer=nil; end;
			end;
		end;

		if (GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0) then
			if (Lootomatic_Settings.LootMaster == true  and GetLootMethod()~="master") then
				Lootomatic_Settings.LootMaster = false;
				Lootomatic.Func.AddChatMessage(string.gsub(tostring(Lootomatic.Strings.RollChange),"<ROLLSETTING>","\""..LOOT_ALTERNATE.."\""));
			end;
			if (Lootomatic_Settings.LootMaster == false and GetLootMethod()=="master") then
				Lootomatic_Settings.LootMaster = true;
				Lootomatic.Func.AddChatMessage(string.gsub(tostring(Lootomatic.Strings.RollChange),"<ROLLSETTING>","\""..LOOT_MASTER_LOOTER.."\""));
			end;
			if (Lootomatic_Settings.Roll ~= GetLootThreshold()+2) then
				Lootomatic_Settings.Roll = GetLootThreshold()+2;
				Lootomatic.Func.AddChatMessage(string.gsub(tostring(Lootomatic.Strings.RollChange),"<ROLLSETTING>",""..Lootomatic.ListEntries[Lootomatic_Settings.Roll]..""));
			end;
		end;
	end;
end;



function Lootomatic.Func.Get_SearchResults(name,type,mode)
	local SearchResults = {};
	local SearchFlag = false;
	-- check characterspecific rules first
		if(Lootomatic.DataMirror[name] ~= nil)then
			if (Lootomatic.DataMirror[name].Char == UnitName("player")) then
					if (string.match(name, "^"..string.gsub(string.gsub(Lootomatic.DataMirror[name].Name, "(%W)", "%%%1"),"%%%*",".*").."$") ~= nil) then
				--table.insert(SearchResults,{Lootomatic_Settings.ItemFilter[i]["Name"],Lootomatic_Settings.ItemFilter[i][mode]});
						table.insert(SearchResults,{Lootomatic.DataMirror[name].Name,Lootomatic.DataMirror[name][mode]});
						SearchFlag = true;
					end;
			
			else
				if(Lootomatic.DataMirror["$"..type] ~= nil)then
					if (Lootomatic.DataMirror["$"..type].Char ~= nil  and Lootomatic.DataMirror["$"..type].Char == UnitName("player")) then
						table.insert(SearchResults,{Lootomatic.DataMirror["$"..type].Name,Lootomatic.DataMirror["$"..type][mode]})
						SearchFlag = true;
					end
				end;
			end;
		end;

	-- if no results in characterspecific, search for global rules
 	if (SearchFlag == false) then
		if(Lootomatic.DataMirror[name] ~= nil )then
			if (Lootomatic.DataMirror[name].Char == nil) then
				if (string.match(name, "^"..string.gsub(string.gsub(Lootomatic.DataMirror[name].Name, "(%W)", "%%%1"),"%%%*",".*").."$") ~= nil) then
					--table.insert(SearchResults,{Lootomatic_Settings.ItemFilter[i]["Name"],Lootomatic_Settings.ItemFilter[i][mode]});
					table.insert(SearchResults,{Lootomatic.DataMirror[name].Name,Lootomatic.DataMirror[name][mode]});
				end;
			end;
		else
			if(Lootomatic.DataMirror["$"..type] ~= nil)then
					if (Lootomatic.DataMirror["$"..type].Char == nil) then
					table.insert(SearchResults,{Lootomatic.DataMirror["$"..type].Name,Lootomatic.DataMirror["$"..type][mode]})
					
					end
			end;
		end;
	end;

 	if (table.maxn(SearchResults)>0) then
		table.sort(SearchResults,Lootomatic.Func.Sort_SearchResults);
		
	end;

	return SearchResults;
end;

function Lootomatic.Func.Sort_SearchResults(a,b) -- Sort the Searchresults of the ItemFilter, to find the most precise match
	if     (string.find(a[1],"^%$") == nil) then return true;
	elseif (string.len(string.gsub(a[1],"\*","")) > string.len(string.gsub(b[1],"\*",""))) then return true; end;
	return false;
end;

function Lootomatic.Func.CheckRollFrame(Rollframe)
	if (Rollframe.lootIndex ~= nil) then
		if (Lootomatic_Settings.Enabled == true and (not AddonManager or Lootomatic_Settings.AM == true)) then
			local name, icon, itemCount, quality = GetLootRollItemInfo(Rollframe.lootIndex);
			if (name ~= nil and quality ~= nil) then
				local lootmode = nil;

				local type = Lootomatic.Func.GetItemType(name,Rollframe.lootIndex);
				local SearchResults = Lootomatic.Func.Get_SearchResults(name,type,"Roll");

				if (quality <= Lootomatic_Settings.AutoGreed - 2) then lootmode = "greed"; end;
				if (quality <= Lootomatic_Settings.AutoPass  - 2) then lootmode = "pass";  end;

				if (type==Lootomatic.Keywords.quest and Lootomatic_Settings.RollQuest==true) then lootmode=nil; end;

				if (table.maxn(SearchResults)>0) then
					    if (SearchResults[1][2]==2) then lootmode="pass";
					elseif (SearchResults[1][2]==3) then lootmode="greed";
					elseif (SearchResults[1][2]==4) then lootmode="roll";
					elseif (SearchResults[1][2]==5) then lootmode=nil; end;
				end;

				    if (lootmode == "pass")  then local frame=getglobal("Lootomatic_"..Rollframe:GetName().."_Selection"); frame.lootmode=lootmode; frame:ClearAllAnchors(); frame:SetAnchor("CENTER","CENTER", getglobal(Rollframe:GetName().."CancelButton"), 0, 0); frame:Show();
				elseif (lootmode == "greed") then local frame=getglobal("Lootomatic_"..Rollframe:GetName().."_Selection"); frame.lootmode=lootmode; frame:ClearAllAnchors(); frame:SetAnchor("CENTER","CENTER", getglobal(Rollframe:GetName().."GreedButton") , 0, 0); frame:Show();
				elseif (lootmode == "roll")  then local frame=getglobal("Lootomatic_"..Rollframe:GetName().."_Selection"); frame.lootmode=lootmode; frame:ClearAllAnchors(); frame:SetAnchor("CENTER","CENTER", getglobal(Rollframe:GetName().."RollButton")  , 0, 0); frame:Show();
				else getglobal("Lootomatic_"..Rollframe:GetName().."_Selection"):Hide(); end;
			end;
		end;
	end;
end;

function Lootomatic.Func.CheckBootyFrame()
	if (not IsShiftKeyDown()) then
		if (not(UnitSex("target")==3 and Lootomatic_Settings.AutoLootBoss==false)) then
			local closeframe = 0;
			local i=0;
			while true do
				i=i+1;
				local texture, name, count, quality = GetBootyItemInfo(i);
				if (name ~= nil and quality ~= nil) then
					local loot = false;
					local type = Lootomatic.Func.GetItemType(name,GetBootyItemLink(i));
					local SearchResults = Lootomatic.Func.Get_SearchResults(name,type,"Loot");

					if (quality <= Lootomatic_Settings.AutoLoot - 2) then loot = true; else closeframe = 1; end;

					if (type==Lootomatic.Keywords.quest and Lootomatic_Settings.LootQuest==true) then loot=false; end;

					if (table.maxn(SearchResults)>0) then
						    if (SearchResults[1][2]==2) then loot = false; if (closeframe==0) then closeframe = 2; end;
						elseif (SearchResults[1][2]> 2) then loot = true; end;
					end;

					if (loot == true) then ClickBootyItem(i); end;
				else
					break;
				end;
 			if (closeframe == 2 and Lootomatic_Settings.LootClose == true) then Lootomatic.Data.BootyCloseTimer = GetTickCount(); end;
			end;
		end;
	end;
end;

function Lootomatic.Func.SearchGarbage()
	local garbagecount = 0;
	local dropquestitem = false;
	Lootomatic.GarbageArray={};

	for i = 1,BAG_MAX_ITEMS_ALL do
		local _, letTime = GetBagPageLetTime(math.ceil(i/30));
		if (letTime ~= -1) then
			local id, icon, name, count, locked, quality = GetBagItemInfo(i);
			if ( id and name ) then
				local type = Lootomatic.Func.GetItemType(name,GetBagItemLink(id));
				local SearchResults = Lootomatic.Func.Get_SearchResults(name,type,"Loot");

				if (table.maxn(SearchResults)>0) then
					if (SearchResults[1][2]==4) then
						table.insert(Lootomatic.GarbageArray,{i,name,count});
						if (type==Lootomatic.Keywords.ammo) then count = count/Lootomatic_Settings.DropAmmo; end;
						garbagecount = garbagecount + count;
						if (type==Lootomatic.Keywords.quest and Lootomatic_Settings.DropQuest==true) then dropquestitem=true; end;
					end;
				end;
			end;
		end;
	end;

	    if ((garbagecount >= Lootomatic_Settings.DropItems and Lootomatic_Settings.DropItems~=0) or dropquestitem) then
		StaticPopup_Show("LOOTOMATIC_DELETE_ITEMS");
 	elseif (garbagecount > 0) then
 		Lootomatic.Func.DropGarbage();
	end;
end;

function Lootomatic.Func.ClearBackUp()
	Lootomatic_Settings_Backup = nil;
	Lootomatic.Func.AddChatMessage(""..Lootomatic_ClearBackup.."");
end
function Lootomatic.Func.CreateBackUp()
	

			if(Lootomatic_Settings_Backup == nil)then
				Lootomatic_Settings_Backup = Lootomatic.Defaults;
			end
			local Transfer_Lootomatic_Settings = Lootomatic_Settings;

			for i,v in pairs(Lootomatic_Settings) do
				if (type(Lootomatic_Settings_Backup[i]) == type(Transfer_Lootomatic_Settings[i])) then
					Lootomatic_Settings_Backup[i] = Transfer_Lootomatic_Settings[i];
				end;
			end;
	Lootomatic.Func.AddChatMessage(""..Lootomatic_CreateBackup.."");
end
function Lootomatic.Func.DropGarbage()
	for n=1,table.maxn(Lootomatic.GarbageArray) do
		local id, icon, name, count = GetBagItemInfo(Lootomatic.GarbageArray[n][1]);

		-- prevent deleting wrong items, when user moves items inside the bag, while deleting is delayed because of confirmationdialog
		if (name==Lootomatic.GarbageArray[n][2] and count==Lootomatic.GarbageArray[n][3]) then
			PickupBagItem(id);
			DeleteCursorItem();
		end;
	end;
end;

function Lootomatic.Func.GetItemType(itemname,link)
	if (link~=nil and type(itemname)=="string") then
		if (Lootomatic.ItemTypeData[itemname] == nil) then
			Lootomatic.ItemTypeData[itemname] = Lootomatic.Keywords.none;

			    if (type(link)=="string") then -- Option for Bagframe and Bootyframe
				Lootomatic.Func.ResetInfoTooltip();
				Lootomatic_InfoTooltip:SetHyperLink(link);
			elseif (type(link)=="number") then -- Workaround for Rollframe, there's no function that returns an Itemlink...
				Lootomatic.Func.ResetInfoTooltip();
	 			Lootomatic_InfoTooltip:SetLootItem(link);
			else -- Just for safety...
				return Lootomatic.Keywords.none;
			end;

			for n=2,10 do
				local left1 = getglobal("Lootomatic_InfoTooltipTextLeft"..n):GetText();
				if (string.len(left1) > 0) then
					if (left1 == TEXT('SOULBOUND_QUEST')) then
						Lootomatic.ItemTypeData[itemname] = Lootomatic.Keywords.quest;
						break;
					end;

					if (left1 == TEXT('Sys200850_shortnote')) then
						Lootomatic.ItemTypeData[itemname] = Lootomatic.Keywords.craft;
						break;
					end;

					if (string.find(left1,"^"..TEXT('SYS_TOOLTIP_RUNE_LEVEL').."$")) then
						local left2 = getglobal("Lootomatic_InfoTooltipTextLeft"..(n+1)):GetText();
						if (left2 == TEXT('ITEM_RUNE')) then
							Lootomatic.ItemTypeData[itemname] = Lootomatic.Keywords.rune..string.gsub(left1,"^.* (%d)$","%1");
							break;
						end;
					end;
				else
					break;
				end;

				local right = getglobal("Lootomatic_InfoTooltipTextRight"..n):GetText();
				if (string.len(right) > 0) then
					if (right == TEXT('SYS_WEAPON_POS04')) then
						Lootomatic.ItemTypeData[itemname] = Lootomatic.Keywords.ammo;
						break;
					end;
				end;
			end;
		end;
		return Lootomatic.ItemTypeData[itemname]
	end;
	return Lootomatic.Keywords.none;
end;

function Lootomatic.Func.ResetInfoTooltip()
	for n=1,11 do
		getglobal("Lootomatic_InfoTooltipTextLeft" ..n):SetText("");
		getglobal("Lootomatic_InfoTooltipTextRight"..n):SetText("");
	end;
end;




----------------------------------------------------------------------------------------------------
-------------------- ChatMessages Output and Setup -------------------------------------------------
----------------------------------------------------------------------------------------------------

function Lootomatic.Func.AddChatMessage(message)
	if (message~="nil") then
		for n=1,10 do
			if (Lootomatic_Settings.ChatFrames[n]) then
				getglobal("ChatFrame"..n):AddMessage("|Hlootomatic:0|h["..Lootomatic.Data.Name.."]|h: "..message,Lootomatic_Settings.ChatColor.r,Lootomatic_Settings.ChatColor.g,Lootomatic_Settings.ChatColor.b);
			end;
		end;
	end;
end;

function Lootomatic.Func.ACCS_GetChecked(frame)
	return Lootomatic_Settings.ChatFrames[frame];
end;
function Lootomatic.Func.ACCS_SetChecked(frame,mode)
	if (type(mode)=="boolean") then
		Lootomatic_Settings.ChatFrames[frame] = mode;
	else
		Lootomatic_Settings.ChatFrames[frame] = true;
	end;
end;

function Lootomatic.Func.ACCS_GetColor()
	return Lootomatic_Settings.ChatColor.r,Lootomatic_Settings.ChatColor.g,Lootomatic_Settings.ChatColor.b;
end;
function Lootomatic.Func.ACCS_SetColor(r,g,b)
	Lootomatic_Settings.ChatColor.r = r;
	Lootomatic_Settings.ChatColor.g = g;
	Lootomatic_Settings.ChatColor.b = b;
end;




----------------------------------------------------------------------------------------------------
-------------------- New content/behaviour of original frames --------------------------------------
----------------------------------------------------------------------------------------------------

function Lootomatic.Func.UIParent_OnEvent(this, event)
	if ( event == "DELETE_QUESETITEM_CONFIRM" ) then
		StaticPopup_Show("DELETE_ITEM", arg1);
	else
		Sol.hooks.GetOriginalFn(Lootomatic.Data.Name, "UIParent_OnEvent") (this, event)
	end;
end;

function Lootomatic.Func.GroupLootFrame_OnShow(this)
	Sol.hooks.GetOriginalFn(Lootomatic.Data.Name, "GroupLootFrame_OnShow") (this)
	Lootomatic.Func.CheckRollFrame(this);
end;

function Lootomatic.Func.GroupLootFrame_Timer(frame,elapsedTime)
	frame.timer = frame.timer - elapsedTime;
	if (frame.timer <= 0) then
		frame:Hide();
		Sol.hooks.GetOriginalFn(Lootomatic.Data.Name, "RollOnLoot") (frame:GetParent().lootIndex, frame.lootmode);
	end;
end;

function Lootomatic.Func.RollOnLoot(frame,mode)
 	local name, icon, itemCount, quality = GetLootRollItemInfo(frame);

 	if (name ~= nil and IsCtrlKeyDown()) then
	
			if (Lootomatic.DataMirror[name].Name == name and Lootomatic.DataMirror[name].Char == nil) then
				table.remove(Lootomatic_Settings.ItemFilter,Lootomatic.DataMirror[name].Index);
				Lootomatic.DataMirror[name]= nil;
				
			end;
		

		local rollmode=1;
		    if (mode=="roll")  then rollmode=4;
		elseif (mode=="greed") then rollmode=3;
		                       else rollmode=2; end;

		table.insert(Lootomatic_Settings.ItemFilter,
			{
			Name = name,
			Loot = 1,
			Roll = rollmode,
			});
			
		Lootomatic.DataMirror[name]= { Name = name, Loot = 1, Roll = rollmode, };
		
		table.sort(Lootomatic_Settings.ItemFilter,Lootomatic.Func.ItemFilter_ListSort);
		Lootomatic.DataMirror = Lootomatic.Func.ItemFilter_SyncList(Lootomatic_Settings.ItemFilter,Lootomatic.DataMirror);
		--Lootomatic.DataMirror][name] musnt be sorted 
		
		Lootomatic.Func.AddChatMessage(string.gsub(string.gsub(tostring(Lootomatic.Strings.AddQuickFilter1),"<ITEM>",tostring(name)),"<ROLL>",tostring(Lootomatic.Strings.RollStatus[rollmode])));

	elseif (name ~= nil and IsShiftKeyDown()==true) then
		
			if (Lootomatic.DataMirror[name].Name == name and Lootomatic.DataMirror[name].Char == UnitName("player")) then
				table.remove(Lootomatic_Settings.ItemFilter,Lootomatic.DataMirror[name].Index);
				Lootomatic.DataMirror[name] = nil;
			end;
		

		local rollmode=1;
		    if (mode=="roll")  then rollmode=4;
		elseif (mode=="greed") then rollmode=3;
		                       else rollmode=2; end;

		table.insert(Lootomatic_Settings.ItemFilter,
			{
			Name = name,
			Loot = 1,
			Roll = rollmode,
			Char = UnitName("player"),
			});
			Lootomatic.DataMirror[name] = { Name = name, Loot = 1, Roll = rollmode, Char = UnitName("player"),};
		table.sort(Lootomatic_Settings.ItemFilter,Lootomatic.Func.ItemFilter_ListSort);
		Lootomatic.DataMirror = Lootomatic.Func.ItemFilter_SyncList(Lootomatic_Settings.ItemFilter,Lootomatic.DataMirror);
		
		Lootomatic.Func.AddChatMessage(string.gsub(string.gsub(tostring(Lootomatic.Strings.AddQuickFilter2),"<ITEM>",tostring(name)),"<ROLL>",tostring(Lootomatic.Strings.RollStatus[rollmode])));

	end;

 	Sol.hooks.GetOriginalFn(Lootomatic.Data.Name, "RollOnLoot") (frame, mode)
end;

function Lootomatic.Func.RollOnLoot_Tooltips()
	if (Lootomatic_Settings.RollTooltip) then
		GROUPLOOT_ROLL   = "|cff00c0f3"..Lootomatic.Data.GROUPLOOT_ROLL  .."|r\n|cffFFFE80["..Lootomatic.Data.Name.."]:|r "..tostring(Lootomatic.Strings.RollFrameSave);
		GROUPLOOT_GREED  = "|cff00c0f3"..Lootomatic.Data.GROUPLOOT_GREED .."|r\n|cffFFFE80["..Lootomatic.Data.Name.."]:|r "..tostring(Lootomatic.Strings.RollFrameSave);
		GROUPLOOT_CANCEL = "|cff00c0f3"..Lootomatic.Data.GROUPLOOT_CANCEL.."|r\n|cffFFFE80["..Lootomatic.Data.Name.."]:|r "..tostring(Lootomatic.Strings.RollFrameSave);
	else
		GROUPLOOT_ROLL   = "|cff00c0f3"..Lootomatic.Data.GROUPLOOT_ROLL  .."|r\n|cffFFFE80["..Lootomatic.Data.Name.."]";
		GROUPLOOT_GREED  = "|cff00c0f3"..Lootomatic.Data.GROUPLOOT_GREED .."|r\n|cffFFFE80["..Lootomatic.Data.Name.."]";
		GROUPLOOT_CANCEL = "|cff00c0f3"..Lootomatic.Data.GROUPLOOT_CANCEL.."|r\n|cffFFFE80["..Lootomatic.Data.Name.."]";
	end;
end;

function Lootomatic.Func.BagItemButton_OnClick(frame, button, ignoreShift)
	if (button=="LBUTTON" and IsShiftKeyDown() and Lootomatic_ItemFilterFrame:IsVisible()) then
		local index, file, name, itemCount, locked = GetBagItemInfo(frame:GetID());
		if (name) then Lootomatic.Func.ItemFilter_EnterName(name); end;
	else
		Sol.hooks.GetOriginalFn(Lootomatic.Data.Name, "BagItemButton_OnClick") (frame, button, ignoreShift)
	end;
end;

function Lootomatic.Func.Hyperlink_Assign(link, key)
	Sol.hooks.GetOriginalFn(Lootomatic.Data.Name, "Hyperlink_Assign")(link,key);

	local _type, _data, _name = ParseHyperlink(link);
	if (_type=="item" and key == "RBUTTON" ) then
  		local menuitem = {};
		menuitem.notCheckable = 1;
		menuitem.text = "|cffFFFE80["..Lootomatic.Data.Name.."]:|r "..tostring(Lootomatic.Strings.AddFilter);
		menuitem.func = function()
			Lootomatic_InfoTooltip:SetHyperLink(link);
			Lootomatic_ChatlinkDropTab.itemname = Lootomatic_InfoTooltipTextLeft1:GetText();

			local x,y = GetCursorPos();
			Lootomatic_ChatlinkDropTab:ClearAllAnchors();
			Lootomatic_ChatlinkDropTab:SetAnchor("BOTTOMLEFT","TOPLEFT",UIParent,x/GetUIScale(),y/GetUIScale());

			Lootomatic_ChatlinkDropTab:Show();
		end;
		UIDropDownMenu_AddButton(menuitem, 1);
		UIDropDownMenu_Refresh(ChatFrameDropDown);
	elseif (_type=="lootomatic" and key == "RBUTTON" ) then
		PlaySoundByPath("sound\\interface\\ui_dropdown_open.mp3");
		ToggleDropDownMenu( Lootomatic_ChatFrameDropdown, 1, nil, "cursor" , 0 , 0 );
	end;
end;

function Lootomatic.Func.ChatFrame_OnEvent(this, event)
	if ( event == "CHAT_MSG_SYSTEM" and type(arg1)=="string") then
		for n=1,table.maxn(Lootomatic.BlockMessages) do
			if (string.match(arg1, Lootomatic.BlockMessages[n])) then return; end;
		end;

		local playername = UnitName("player"); -- workaround, UnitName returns nil during loading screen

		if (type(playername)=="string") then
			if (arg1 == string.gsub(TEXT('SYS_ADD_PARTY'),"%%s",playername)) then
				if (Lootomatic_Settings.LootMaster==true) then
					SetLootMethod("master");
				elseif (Lootomatic_Settings.Roll==101) then
					SetLootThreshold(99);
					SetLootMethod("freeforall");
				else
					SetLootThreshold(Lootomatic_Settings.Roll-2);
				end;
			elseif (string.find(arg1, "^%[[^%]]*%] : ") ~= nil) then
				local itemstring = string.gsub(arg1,"^.*(|H.*|h).*$","%1");

				for roll=1,3 do
					if (string.find(string.gsub(arg1,"^[^:]*:",""),Lootomatic.Rolls[roll]) ~= nil) then
						for n=1,6 do
							if (string.find(itemstring,"|cff"..Lootomatic.QualityColors[n])~=nil and Lootomatic_Settings.RollResults[n][roll]==false) then
								return;
							end;
						end;

						local info   = ChatTypeInfo["SYSTEM"];
						local colors =
							{
							{info.r*0.75      , info.g*0.75      , info.b*0.75      },
							{info.r           , info.g           , info.b           },
							{1-(1-info.r)*0.75, 1-(1-info.g)*0.75, 1-(1-info.b)*0.75},
							};

						if (Lootomatic_Settings.RollNewStyle) then
							local player = string.gsub(arg1,"^%[([^%]]*)%].*$","%1");
							local result = string.gsub(arg1,"^.*|h *","");
							this:AddMessage(itemstring.." - |Hplayer:"..player.."|h["..player.."]|h "..Lootomatic.Rolls[roll].." "..result,colors[roll][1],colors[roll][2],colors[roll][3]);
						else
							this:AddMessage(arg1,colors[roll][1],colors[roll][2],colors[roll][3]);
						end;
						return;
					end;
				end;
			end;
		end;
	end;
	Sol.hooks.GetOriginalFn(Lootomatic.Data.Name, "ChatFrame_OnEvent")(this, event);
end;

function Lootomatic.Func.ToggleDropDownMenu(dropDownFrame, level, value, anchorName, xOffset, yOffset)
	Sol.hooks.GetOriginalFn(Lootomatic.Data.Name, "ToggleDropDownMenu")(dropDownFrame, level, value, anchorName, xOffset, yOffset);
	if (Lootomatic.Data.RollresultHack == true) then
		Lootomatic.Data.RollresultHack = nil;
		Lootomatic_RollresultSettings:Show();
	else
		Lootomatic_RollresultSettings:Hide();
	end;
end;



----------------------------------------------------------------------------------------------------
-------------------- Minimap-Menue -----------------------------------------------------------------
----------------------------------------------------------------------------------------------------

function Lootomatic.Func.MainMenue()
	Lootomatic.Data.RollresultHack = false;

	if (UIDROPDOWNMENU_MENU_LEVEL == 1) then
		local menuitem = {};
		menuitem.func = function() Lootomatic_Settings.Enabled = not Lootomatic_Settings.Enabled; end;
		if (Lootomatic_Settings.Enabled==true) then menuitem.text = Lootomatic.Strings.MEnabled;  menuitem.checked = 1;
		                                       else menuitem.text = Lootomatic.Strings.MDisabled; menuitem.checked = nil; end;
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

		local menuitem = {};
		menuitem.notCheckable = 1;

		menuitem.value = 1;
		if (IsPartyLeader("player")==true or (GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0 ) ) then
			menuitem.hasArrow = 1; else menuitem.disabled = true;
		end;

		if (Lootomatic_Settings.LootMaster==true) then
			menuitem.text = tostring(Lootomatic.Strings.Roll)..": "..Lootomatic.ListEntries[0]..", "..Lootomatic.ListEntries[Lootomatic_Settings.Roll];
		else
			menuitem.text = tostring(Lootomatic.Strings.Roll)..": "..Lootomatic.ListEntries[Lootomatic_Settings.Roll];
		end;
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

		menuitem.value = 2;
		menuitem.hasArrow = 1;
		menuitem.disabled = nil;
		menuitem.text = tostring(Lootomatic.Strings.AutoLoot) ..": "..Lootomatic.ListEntries[Lootomatic_Settings.AutoLoot];
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

		menuitem.value = 3;
		menuitem.text = tostring(Lootomatic.Strings.AutoPass) ..": "..Lootomatic.ListEntries[Lootomatic_Settings.AutoPass];
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

		menuitem.value = 4;
		menuitem.text = tostring(Lootomatic.Strings.AutoGreed)..": "..Lootomatic.ListEntries[Lootomatic_Settings.AutoGreed];
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

		menuitem.value = 5;
		menuitem.text = tostring(Lootomatic.Strings.RollMessages);
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

		local menuitem = {};
		menuitem.notCheckable = 1;
		menuitem.text = tostring(Lootomatic.Strings.ItemFilter);
		menuitem.func = function() Lootomatic.Func.FadeFrames("Lootomatic_ItemFilterFrame"); Lootomatic_ItemFilterFrame_Itemname:ClearFocus(); end;
		UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

		if (AddonConfig==nil) then
			menuitem.text = tostring(Lootomatic.Strings.Settings);
			menuitem.func = function() Lootomatic.Func.FadeFrames("Lootomatic_SettingsFrame"); end;
			UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
		end;
	else
		local menuitem = {};

		if (UIDROPDOWNMENU_MENU_VALUE == 1) then
			for i=2,7 do
				menuitem.text = Lootomatic.ListEntries[i];
				menuitem.func = function()
						if (IsPartyLeader("player")) then
							if (GetLootMethod()=="freeforall") then
								SetLootMethod("alternate");
							else
								SetLootThreshold(i-2);
							end;
						elseif (GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0) then
							Lootomatic_Settings.Roll=i;
						end;
						CloseDropDownMenus(1); ToggleDropDownMenu(Lootomatic_Dropdown);
						end;
				if (Lootomatic_Settings.Roll==i) then menuitem.checked = 1;
			 	                                 else menuitem.checked = nil; end;
				UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
			end;

			menuitem.text = Lootomatic.ListEntries[101];
			menuitem.func = function()
					if (IsPartyLeader("player")) then
						SetLootMethod("freeforall");
					elseif (GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0) then
						Lootomatic_Settings.Roll=101;
					end;
					CloseDropDownMenus(1); ToggleDropDownMenu(Lootomatic_Dropdown);
					end;
			if (Lootomatic_Settings.Roll==101) then menuitem.checked = 1;
			                                   else menuitem.checked = nil; end;
			UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

			UIDropDownMenu_AddButton({},UIDROPDOWNMENU_MENU_LEVEL);

			menuitem.text = Lootomatic.ListEntries[0];
			menuitem.func = function()
					if (IsPartyLeader("player")) then
						if (GetLootMethod()=="master") then
							SetLootMethod("alternate");
						else
							SetLootMethod("master");
						end;
					elseif (GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0) then
						Lootomatic_Settings.LootMaster = not Lootomatic_Settings.LootMaster;
					end;
					CloseDropDownMenus(1); ToggleDropDownMenu(Lootomatic_Dropdown);
					end;
			if (Lootomatic_Settings.LootMaster==true) then menuitem.checked = 1;
			                                          else menuitem.checked = nil; end;
			UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
		elseif (UIDROPDOWNMENU_MENU_VALUE == 2) then
			for i=1,7 do
				menuitem.text = Lootomatic.ListEntries[i];
				menuitem.func = function() Lootomatic_Settings.AutoLoot = i; CloseDropDownMenus(1); ToggleDropDownMenu(Lootomatic_Dropdown); end;
				if (Lootomatic_Settings.AutoLoot==i) then menuitem.checked = 1;
				                                     else menuitem.checked = nil; end;
				UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
			end;
			menuitem = {};
			menuitem.isTitle = true;
			UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

			menuitem = {};
			menuitem.text = tostring(Lootomatic.Strings.NoBoss);
			menuitem.func = function() Lootomatic_Settings.AutoLootBoss = not Lootomatic_Settings.AutoLootBoss; CloseDropDownMenus(1); ToggleDropDownMenu(Lootomatic_Dropdown); end;
			if (Lootomatic_Settings.AutoLootBoss==false) then menuitem.checked = 1;
			                                             else menuitem.checked = nil; end;
			UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
		elseif (UIDROPDOWNMENU_MENU_VALUE == 3) then
			for i=1,7 do
				menuitem.text = Lootomatic.ListEntries[i];
				menuitem.func = function() Lootomatic_Settings.AutoPass = i; CloseDropDownMenus(1); ToggleDropDownMenu(Lootomatic_Dropdown); end;
				if (Lootomatic_Settings.AutoPass==i) then menuitem.checked = 1;
				                                     else menuitem.checked = nil; end;
				UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
			end;
		elseif (UIDROPDOWNMENU_MENU_VALUE == 4) then
			for i=1,7 do
				menuitem.text = Lootomatic.ListEntries[i];
				menuitem.func = function() Lootomatic_Settings.AutoGreed = i; CloseDropDownMenus(1); ToggleDropDownMenu(Lootomatic_Dropdown); end;
				if (Lootomatic_Settings.AutoGreed==i) then menuitem.checked = 1;
				                                      else menuitem.checked = nil; end;
				UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
			end;
		elseif (UIDROPDOWNMENU_MENU_VALUE == 5) then
			Lootomatic.Data.RollresultHack = true;
			DropDownList2.numButtons = 1;
			DropDownList2.maxWidth = Lootomatic_RollresultSettings.width;


-- 			menuitem.text = tostring(Lootomatic.Strings.RollMessages);
-- 			menuitem.isTitle = 1;
-- 			UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);

-- 			for i=2,7 do
-- 				menuitem.text = Lootomatic.ListEntries[i];
-- 				menuitem.func = function() Lootomatic_Settings.Chatfilter[i-1] = not Lootomatic_Settings.Chatfilter[i-1]; CloseDropDownMenus(1); ToggleDropDownMenu(Lootomatic_Dropdown); end;
-- 				if (Lootomatic_Settings.Chatfilter[i-1]==true) then menuitem.checked = 1;
-- 				                                               else menuitem.checked = nil; end;
-- 				UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL);
-- 			end;
		end;
	end;
end;





----------------------------------------------------------------------------------------------------
-------------------- Miscallaneous -----------------------------------------------------------------
----------------------------------------------------------------------------------------------------

function Lootomatic.Func.Tooltip(Object)
	GameTooltip:SetOwner(Object,"ANCHOR_BOTTOM",0,0);

	if (Object:GetName()=="Lootomatic_Minimap") then
		GameTooltip:SetText("|cffFFFE80"..Lootomatic.Data.Name.." "..Lootomatic.Data.Version.."|r");

		if (Lootomatic_Settings.Enabled == true) then GameTooltip:AddLine("   "..tostring(Lootomatic.Strings.Enabled) ,0,1,0);
		                                         else GameTooltip:AddLine("   "..tostring(Lootomatic.Strings.Disabled),1,0,0); end;

		local bosses = "";
		if (Lootomatic_Settings.AutoLootBoss == false) then bosses = ", "..tostring(Lootomatic.Strings.NoBoss); end;

		if (Lootomatic_Settings.LootMaster==true) then
			GameTooltip:AddLine("   "..tostring(Lootomatic.Strings.Roll)     ..": "..Lootomatic.ListEntries[0]..", "..Lootomatic.ListEntries[Lootomatic_Settings.Roll]);
		else
			GameTooltip:AddLine("   "..tostring(Lootomatic.Strings.Roll)     ..": "..Lootomatic.ListEntries[Lootomatic_Settings.Roll]);
		end;
		GameTooltip:AddLine("   "..tostring(Lootomatic.Strings.AutoLoot) ..": "..Lootomatic.ListEntries[Lootomatic_Settings.AutoLoot]..bosses);
		GameTooltip:AddLine("   "..tostring(Lootomatic.Strings.AutoPass) ..": "..Lootomatic.ListEntries[Lootomatic_Settings.AutoPass]);
		GameTooltip:AddLine("   "..tostring(Lootomatic.Strings.AutoGreed)..": "..Lootomatic.ListEntries[Lootomatic_Settings.AutoGreed]);

		GameTooltip:AddLine(UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95);

	elseif (Lootomatic.Strings["Tooltip_"..Object:GetName()]~=nil) then
		GameTooltip:SetText("|cffFFFE80"..Lootomatic.Strings["Tooltip_"..Object:GetName()][1].."|r");
		GameTooltip:AddLine(              Lootomatic.Strings["Tooltip_"..Object:GetName()][2]      );

		if (table.maxn(Lootomatic.Strings["Tooltip_"..Object:GetName()])>2) then
			if (IsShiftKeyDown()) then
				for n=3,table.maxn(Lootomatic.Strings["Tooltip_"..Object:GetName()]) do
					if (type(Lootomatic.Strings["Tooltip_"..Object:GetName()][n])=="table")
					then GameTooltip:AddDoubleLine(Lootomatic.Strings["Tooltip_"..Object:GetName()][n][1],Lootomatic.Strings["Tooltip_"..Object:GetName()][n][2]);
					else GameTooltip:AddLine(Lootomatic.Strings["Tooltip_"..Object:GetName()][n]); end;
				end;
			else
				GameTooltip:AddLine(Lootomatic.Strings["Tooltip_LongText"], 0, 0.75, 0.95);
			end;
		end;
	end;
end;

function Lootomatic.Func.DropTab_Display(Object)
	local parent=Object:GetParent():GetName();
	local x=string.gsub(Object:GetName(),"^.*_","");
	local loot = tonumber(string.sub(x,1,1));
	local roll = tonumber(string.sub(x,2));

	local RollTextures =
		{
		[1]="Interface/Addons/Lootomatic/Textures/roll-pass",
		[2]="Interface/Addons/Lootomatic/Textures/roll-greed",
		[3]="Interface/Addons/Lootomatic/Textures/roll-need",
		[4]="Interface/Addons/Lootomatic/Textures/roll-manual",
		}
	local LootTextures =
		{
		[1]="Interface/Addons/Lootomatic/Textures/loot-dontloot",
		[2]="Interface/Addons/Lootomatic/Textures/loot-loot",
		[3]="Interface/Addons/Lootomatic/Textures/loot-drop",
		}

	if (roll==0) then
		getglobal(parent.."_RollIcon"):Hide();
		getglobal(parent.."_RollText"):Hide();
	else
		getglobal(parent.."_RollIcon"):Show();
		getglobal(parent.."_RollText"):Show();
		getglobal(parent.."_RollIcon"):SetFile(RollTextures[roll]);
		getglobal(parent.."_RollText"):SetText(tostring(Lootomatic.Strings.RollStatus[roll+1]));
	end;
	if (loot==0) then
		getglobal(parent.."_LootIcon"):Hide();
		getglobal(parent.."_LootText"):Hide();
	else
		getglobal(parent.."_LootIcon"):Show();
		getglobal(parent.."_LootText"):Show();
		getglobal(parent.."_LootIcon"):SetFile(LootTextures[loot]);
		getglobal(parent.."_LootText"):SetText(tostring(Lootomatic.Strings.LootStatus[loot+1]));
	end;
	if (roll==0 and loot==0) then
		getglobal(parent.."_LootMarker"):Hide();
		getglobal(parent.."_RollMarker"):Hide();
		getglobal(parent.."_Remove"):Show();
		getglobal(parent.."_Remove"):SetText(tostring(Lootomatic.Strings.Tooltip_Lootomatic_ItemFilterFrame_ItemRemove[1]));
	else
		getglobal(parent.."_Remove"):Hide();
		getglobal(parent.."_LootMarker"):Show();
		getglobal(parent.."_LootMarker"):ClearAllAnchors();
		getglobal(parent.."_LootMarker"):SetAnchor("LEFT","LEFT",getglobal(parent.."_"..loot.."0"),-1,0);
		getglobal(parent.."_RollMarker"):Show();
		getglobal(parent.."_RollMarker"):ClearAllAnchors();
		getglobal(parent.."_RollMarker"):SetAnchor("TOP","TOP",getglobal(parent.."_0"..roll..""),0,-1);
	end;

end;

function Lootomatic.Func.DropTab_Check()
	local x,y = Lootomatic_DropTab:GetPos();
	local a,b = Lootomatic_DropTab:GetRealSize();
	local u,v = GetCursorPos();

	local inside=false;
	if (u>x and u<(x+a) and v>y and v<(y+b)) then inside=true; end;

	if (inside==true) then Lootomatic.Data.DropTabCheck=true; end;
	if (inside==false and Lootomatic.Data.DropTabCheck==true) then Lootomatic_DropTab:Hide(); end;
end;

function Lootomatic.Func.DropTab_OnShow(this)
	this.newCheck = false;
	this.id = nil;

	if (this:GetName() ~= "Lootomatic_ChatlinkDropTab") then
		-- Find Window position, where complete frame is visible
		for n=1,table.maxn(this.Locations) do
			this:ClearAllAnchors();
			this:SetAnchor(unpack(this.Locations[n]));
			if (this:GetTop()>0 and this:GetBottom()<GetScreenHeight() and this:GetLeft()>0 and this:GetRight()<GetScreenWidth()) then
				break;
			end;
		end;

		local id = GetCursorItemInfo();
		local _, name, _ = GetGoodsItemInfo(id);
		this.itemname = name;
		this.id = id;
	end;

	getglobal(this:GetName().."_Itemname"):SetText(this.itemname);

	getglobal(this:GetName().."_LootIcon"):Hide();
	getglobal(this:GetName().."_LootText"):Hide();
	getglobal(this:GetName().."_RollIcon"):Hide();
	getglobal(this:GetName().."_RollText"):Hide();
	getglobal(this:GetName().."_LootMarker"):Hide();
	getglobal(this:GetName().."_RollMarker"):Hide();
end;

function Lootomatic.Func.DropTab_OnUpdate(this)
	local x,y = this:GetPos();
	local a,b = this:GetRealSize();
	local u,v = GetCursorPos();

	local inside=false;
	if (x<u and u<x+a and y<v and v<y+b) then inside=true; end;

	if (inside==true                         ) then this.newCheck=true; end;
	if (inside==false and this.newCheck==true) then this:Hide(); end;
end;

function Lootomatic.Func.Settings_LockOption(frame,mode)
	if (mode) then
		frame:Enable();
		frame:SetAlpha(1);
	else
		frame:Disable();
		frame:SetAlpha(0.5);
	end;
end;

function Lootomatic.Func.Sliders_GetValues(slider)
	if (slider.enable) then
		    if (string.match(slider:GetName(),"Lootomatic_[^_]*_Rollframe_Slider")) then
			Lootomatic_Settings.RollDelay = (slider:GetValue())/2;
		elseif (string.match(slider:GetName(),"Lootomatic_[^_]*_DropItems_SliderItems")) then
			Lootomatic_Settings.DropItems = slider:GetValue();
		elseif (string.match(slider:GetName(),"Lootomatic_[^_]*_DropItems_SliderAmmo")) then
			Lootomatic_Settings.DropAmmo = slider:GetValue();
		elseif (string.match(slider:GetName(),"Lootomatic_[^_]*_DropItems_SliderTimeout")) then
			Lootomatic_Settings.DropTime = slider:GetValue();
			StaticPopupDialogs["LOOTOMATIC_DELETE_ITEMS"]["timeout"] = Lootomatic_Settings.DropTime;
		elseif (slider:GetName()=="Lootomatic_RollFrameGhosts_1_Slider") then
			if (math.abs(slider:GetValue()) < 5) then slider:SetValue(0); end;
			Lootomatic_Settings.RollFrameD = slider:GetValue();
		end;
		Lootomatic.Func.Sliders_SetTitles(slider);
	end;
end;

function Lootomatic.Func.Sliders_SetTitles(slider)
	if (slider.enable) then
		    if (string.match(slider:GetName(),"Lootomatic_[^_]*_Rollframe_Slider") and slider:GetValue() > 0) then
			getglobal(slider:GetName().."_Value"):SetText(tostring(Lootomatic.Strings.Settings_RollPositionTimer)..": "..string.format("%0.1f",slider:GetValue()/2).." s");
		elseif (string.match(slider:GetName(),"Lootomatic_[^_]*_Rollframe_Slider")) then
			getglobal(slider:GetName().."_Value"):SetText(tostring(Lootomatic.Strings.Settings_RollPositionTimerNo));
		elseif (slider:GetName()=="Lootomatic_RollFrameGhosts_1_Slider") then
			getglobal(slider:GetName().."_Value"):SetText(string.format("%d",slider:GetValue()));
			Lootomatic.Func.RollFrameGhosts_Move();
		elseif (string.match(slider:GetName(),"Lootomatic_[^_]*_DropItems_SliderItems")) then
			if (slider:GetValue()==0) then
				getglobal(slider:GetName().."_Value"):SetText(tostring(Lootomatic.Strings.Settings_DropConfirmNo));
				Lootomatic.Func.Settings_LockOption(Lootomatic_SettingsFrame_DropItems_SliderAmmo,false);
				Lootomatic.Func.Settings_LockOption(Lootomatic_AddonConfigFrame_DropItems_SliderAmmo,false);
			else
				getglobal(slider:GetName().."_Value"):SetText(string.gsub(tostring(Lootomatic.Strings.Settings_DropConfirm),"<NUM>",slider:GetValue()));
				Lootomatic.Func.Settings_LockOption(Lootomatic_SettingsFrame_DropItems_SliderAmmo,true);
				Lootomatic.Func.Settings_LockOption(Lootomatic_AddonConfigFrame_DropItems_SliderAmmo,true);
			end;
		elseif (string.match(slider:GetName(),"Lootomatic_[^_]*_DropItems_SliderAmmo")) then
			getglobal(slider:GetName().."_Value"):SetText(string.gsub(tostring(Lootomatic.Strings.Settings_DropAmmo),"<NUM>",slider:GetValue()));
		elseif (string.match(slider:GetName(),"Lootomatic_[^_]*_DropItems_SliderTimeout")) then
			if (slider:GetValue()==0) then
				getglobal(slider:GetName().."_Value"):SetText(tostring(Lootomatic.Strings.Settings_DropTimeoutNo));
				Lootomatic_SettingsFrame_DropItems_DropAuto:Hide();
				Lootomatic_AddonConfigFrame_DropItems_DropAuto:Hide();
			else
				getglobal(slider:GetName().."_Value"):SetText(string.gsub(tostring(Lootomatic.Strings.Settings_DropTimeout),"<NUM>",slider:GetValue()));
				Lootomatic_SettingsFrame_DropItems_DropAuto:Show();
				Lootomatic_AddonConfigFrame_DropItems_DropAuto:Show();
			end;
		end;
	end;
end;

function Lootomatic.Func.DropItems_DropAuto()
	if (Lootomatic_Settings.DropAuto==true) then
		Lootomatic_SettingsFrame_DropItems_DropAuto:SetText(TEXT("YES"));
		Lootomatic_AddonConfigFrame_DropItems_DropAuto:SetText(TEXT("YES"));
	else
		Lootomatic_SettingsFrame_DropItems_DropAuto:SetText(TEXT("NO"));
		Lootomatic_AddonConfigFrame_DropItems_DropAuto:SetText(TEXT("NO"));
	end;
end;


function Lootomatic.Func.RollFrameGhosts_Move()
	Lootomatic_RollFrameGhosts_2:ClearAllAnchors();
	Lootomatic_RollFrameGhosts_3:ClearAllAnchors();
	Lootomatic_RollFrameGhosts_4:ClearAllAnchors();
	Lootomatic_RollFrameGhosts_5:ClearAllAnchors();
	Lootomatic_RollFrameGhosts_6:ClearAllAnchors();

	Lootomatic_RollFrameGhosts_2:SetAnchor("CENTER", "CENTER", Lootomatic_RollFrameGhosts_1, 0, Lootomatic_Settings.RollFrameD);
	Lootomatic_RollFrameGhosts_3:SetAnchor("CENTER", "CENTER", Lootomatic_RollFrameGhosts_2, 0, Lootomatic_Settings.RollFrameD);
	Lootomatic_RollFrameGhosts_4:SetAnchor("CENTER", "CENTER", Lootomatic_RollFrameGhosts_3, 0, Lootomatic_Settings.RollFrameD);
	Lootomatic_RollFrameGhosts_5:SetAnchor("CENTER", "CENTER", Lootomatic_RollFrameGhosts_4, 0, Lootomatic_Settings.RollFrameD);
	Lootomatic_RollFrameGhosts_6:SetAnchor("CENTER", "CENTER", Lootomatic_RollFrameGhosts_5, 0, Lootomatic_Settings.RollFrameD);
end;






----------------------------------------------------------------------------------------------------
-------------------- AddonConfigFrame --------------------------------------------------------------
----------------------------------------------------------------------------------------------------

function Lootomatic.Func.AddonConfig_ReadSettings()
	Lootomatic_AddonConfigFrame_BootyFrame_Move			:SetChecked(Lootomatic_Settings.LootMove);
	Lootomatic_AddonConfigFrame_BootyFrame_Close		:SetChecked(Lootomatic_Settings.LootClose);
	Lootomatic_AddonConfigFrame_BootyFrame_Quest		:SetChecked(Lootomatic_Settings.LootQuest);

	Lootomatic_AddonConfigFrame_Rollframe_Quest			:SetChecked(Lootomatic_Settings.RollQuest);
	Lootomatic_AddonConfigFrame_Rollframe_RollTooltip	:SetChecked(Lootomatic_Settings.RollTooltip);
	Lootomatic_AddonConfigFrame_Rollframe_Slider		:SetValue(Lootomatic_Settings.RollDelay);

	Lootomatic_AddonConfigFrame_DropItems_DropQuest		:SetChecked(Lootomatic_Settings.DropQuest);
	Lootomatic_AddonConfigFrame_DropItems_SliderItems	:SetValue(Lootomatic_Settings.DropItems);
	Lootomatic_AddonConfigFrame_DropItems_SliderAmmo	:SetValue(Lootomatic_Settings.DropAmmo);
	Lootomatic_AddonConfigFrame_DropItems_SliderTimeout	:SetValue(Lootomatic_Settings.DropTime);

	Lootomatic_AddonConfigFrame_Chatframe_ChatOutput	:SetChecked(Lootomatic_Settings.ChatOutput);
	Lootomatic_AddonConfigFrame_Chatframe_RollNewStyle	:SetChecked(Lootomatic_Settings.RollNewStyle);
	
	Lootomatic_AddonConfigFrame_Mixed_ListFilter		:SetChecked(Lootomatic_Settings.ListFilter);
	Lootomatic_AddonConfigFrame_Mixed_BackUp			:SetChecked(Lootomatic_Settings.BackUp);
	
	Lootomatic_Sliders_SetTitles(Lootomatic_AddonConfigFrame_Rollframe_Slider);
	Lootomatic_Sliders_SetTitles(Lootomatic_AddonConfigFrame_DropItems_SliderItems);
	Lootomatic_Sliders_SetTitles(Lootomatic_AddonConfigFrame_DropItems_SliderAmmo);
	Lootomatic_Sliders_SetTitles(Lootomatic_AddonConfigFrame_DropItems_SliderTimeout);
	Lootomatic_Sliders_SetTitles(Lootomatic_AddonConfigFrame_Mixed);
	
	Lootomatic.Func.DropItems_DropAuto();
end;

function Lootomatic.Func.AddonConfig_Apply()
	Lootomatic_Settings.LootMove	= Lootomatic_AddonConfigFrame_BootyFrame_Move:IsChecked();
	Lootomatic_Settings.LootClose	= Lootomatic_AddonConfigFrame_BootyFrame_Close:IsChecked();
	Lootomatic_Settings.LootQuest	= Lootomatic_AddonConfigFrame_BootyFrame_Quest:IsChecked();

	Lootomatic_Settings.RollQuest	= Lootomatic_AddonConfigFrame_Rollframe_Quest:IsChecked();
	Lootomatic_Settings.RollTooltip	= Lootomatic_AddonConfigFrame_Rollframe_RollTooltip:IsChecked();
	Lootomatic_Settings.RollDelay	= Lootomatic_AddonConfigFrame_Rollframe_Slider:GetValue();

	Lootomatic_Settings.DropQuest	= Lootomatic_AddonConfigFrame_DropItems_DropQuest:IsChecked();
	Lootomatic_Settings.DropItems	= Lootomatic_AddonConfigFrame_DropItems_SliderItems:GetValue();
	Lootomatic_Settings.DropAmmo	= Lootomatic_AddonConfigFrame_DropItems_SliderAmmo:GetValue();
	Lootomatic_Settings.DropTime	= Lootomatic_AddonConfigFrame_DropItems_SliderTimeout:GetValue();

	Lootomatic_Settings.ChatOutput	= Lootomatic_AddonConfigFrame_Chatframe_ChatOutput:IsChecked();
	Lootomatic_Settings.RollNewStyle= Lootomatic_AddonConfigFrame_Chatframe_RollNewStyle:IsChecked();
	
	Lootomatic_Settings.ListFilter 	= Lootomatic_AddonConfigFrame_Mixed_ListFilter:IsChecked();
	Lootomatic_Settings.BackUp		= Lootomatic_AddonConfigFrame_Mixed_BackUp:IsChecked();

	if (Lootomatic_AddonConfigFrame_DropItems_DropAuto:GetText()==TEXT("YES")) then
		Lootomatic_Settings.DropAuto = true;
	else
		Lootomatic_Settings.DropAuto = false;
	end;

	Lootomatic.Func.RollOnLoot_Tooltips();
end;

function Lootomatic.Func.AddonConfig_Defaults()
	Lootomatic_Settings.LootMove	= Lootomatic.Defaults.LootMove;
	Lootomatic_Settings.LootClose	= Lootomatic.Defaults.LootClose;
	Lootomatic_Settings.LootQuest	= Lootomatic.Defaults.LootQuest;

	Lootomatic_Settings.RollQuest	= Lootomatic.Defaults.RollQuest;
	Lootomatic_Settings.RollTooltip	= Lootomatic.Defaults.RollTooltip;
	Lootomatic_Settings.RollDelay	= Lootomatic.Defaults.RollDelay;
	Lootomatic_Settings.RollFrameX	= Lootomatic.Defaults.RollFrameX;
	Lootomatic_Settings.RollFrameY	= Lootomatic.Defaults.RollFrameY;
	Lootomatic_Settings.RollFrameD	= Lootomatic.Defaults.RollFrameD;

	Lootomatic_Settings.DropQuest	= Lootomatic.Defaults.DropQuest;
	Lootomatic_Settings.DropItems	= Lootomatic.Defaults.DropItems;
	Lootomatic_Settings.DropAmmo	= Lootomatic.Defaults.DropAmmo;
	Lootomatic_Settings.DropTime	= Lootomatic.Defaults.DropTime;
	Lootomatic_Settings.DropAuto	= Lootomatic.Defaults.DropAuto;

	Lootomatic_Settings.ChatOutput	= Lootomatic.Defaults.ChatOutput;
	Lootomatic_Settings.RollNewStyle= Lootomatic.Defaults.RollNewStyle;
	
	Lootomatic_Settings.ListFilter 	= Lootomatic.Defaults.ListFilter;
	Lootomatic_Settings.BackUp		= Lootomatic.Defaults.BackUp;
--[[	Lootomatic_Settings.ClearBackUp	= Lootomatic.Defaults.ClearBackUp;
	Lootomatic_Settings.CreateBackUp = Lootomatic.Defaults.CreateBackUp;
	]]--
	Lootomatic.Func.AddonConfig_ReadSettings();
end;


----------------------------------------------------------------------------------------------------
-------------------- Item Filter -------------------------------------------------------------------
----------------------------------------------------------------------------------------------------

function Lootomatic.Func.ItemFilter_Repaint()
	local a,b = Lootomatic_ItemFilterFrame_Filterlist:GetSize();
	local maxvalues = math.floor((b-12)/20);
	local playername = "";
	local maxvalue = Lootomatic.Func.ItemFilter_GetDisplayIndex(table.maxn(Lootomatic_Settings.ItemFilter))-maxvalues+1;
	
	if (maxvalue < 1) then maxvalue = 1; end;

	Lootomatic_ItemFilterFrame_ScrollBar:SetMinMaxValues(1,maxvalue);

	local value = Lootomatic_ItemFilterFrame_ScrollBar:GetValue();

	for i=1,30 do
		local index = Lootomatic.Func.ItemFilter_GetRealIndex(value-1+i);

		if (index <= table.maxn(Lootomatic_Settings.ItemFilter) and i <= maxvalues) then
				
				--Lootomatic_Settings.ItemFilter[i]["Name"]
			if (Lootomatic_Settings.ItemFilter[index].Char == nil --[[and Lootomatic_Settings.ItemFilter[index].char ~= playername]]) then
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i):Show();
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Name"):SetText("(GLOBAL)"..tostring(                              Lootomatic_Settings.ItemFilter[index].Name ));
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Loot"):SetText(tostring(Lootomatic.Strings.LootStatus[Lootomatic_Settings.ItemFilter[index].Loot]));
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Roll"):SetText(tostring(Lootomatic.Strings.RollStatus[Lootomatic_Settings.ItemFilter[index].Roll]));
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Name"):SetColor(1,1,1);
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Loot"):SetColor(1,1,1);
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Roll"):SetColor(1,1,1);
			else
				playername=Lootomatic_Settings.ItemFilter[index].Char;
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i):Show();
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Name"):SetText("("..playername..")"..tostring(                              Lootomatic_Settings.ItemFilter[index].Name ));
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Loot"):SetText(tostring(Lootomatic.Strings.LootStatus[Lootomatic_Settings.ItemFilter[index].Loot]));
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Roll"):SetText(tostring(Lootomatic.Strings.RollStatus[Lootomatic_Settings.ItemFilter[index].Roll]));
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Name"):SetColor(0.5,0.5,0.5);
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Loot"):SetColor(0.5,0.5,0.5);
				getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Roll"):SetColor(0.5,0.5,0.5);
			end;
		else
			getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i):Hide();
			getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Name"):SetText("");
			getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Loot"):SetText("");
			getglobal("Lootomatic_ItemFilterFrame_Filterlist_Item"..i.."_Roll"):SetText("");
		end;
	end;

	Lootomatic.Func.ItemFilter_SetValues();
end;

function Lootomatic.Func.ItemFilter_GetRealIndex(x)
	local n=0;
	if(Lootomatic_Settings.ListFilter == true)then
		for i=1,table.maxn(Lootomatic_Settings.ItemFilter) do
			if (Lootomatic_Settings.ItemFilter[i].Char==nil or Lootomatic_Settings.ItemFilter[i].Char==UnitName("player") or Lootomatic_Settings.ItemFilter[i] ~= nil) then n=n+1; end;
			if (n==x) then return i; end;
		end;
	else
		for i=1,table.maxn(Lootomatic_Settings.ItemFilter) do
			if (Lootomatic_Settings.ItemFilter[i].Char==nil
			or  Lootomatic_Settings.ItemFilter[i].Char==UnitName("player")) then n=n+1; end;
			if (n==x) then return i; end;
		end;
	end
	return x;
end;

function Lootomatic.Func.ItemFilter_GetDisplayIndex(x)
	local n=0;
	if(Lootomatic_Settings.ListFilter == true)then
		n=0;
	else
		for i=1,x do
			if (Lootomatic_Settings.ItemFilter[i].Char~=nil
			and Lootomatic_Settings.ItemFilter[i].Char~=UnitName("player")) then n=n+1; end;
		end;
	end;
	return (x-n);
end;

function Lootomatic.Func.ItemFilter_RowClicked(id)
	Lootomatic.Data.ListSelect = Lootomatic.Func.ItemFilter_GetRealIndex(Lootomatic_ItemFilterFrame_ScrollBar:GetValue()+id-1);
	Lootomatic.Func.ItemFilter_SetValues();
end;

function Lootomatic.Func.ItemFilter_SearchName()
	Lootomatic.Data.ListSelect = nil;
	
		if(Lootomatic.DataMirror[Lootomatic_ItemFilterFrame_Itemname:GetText()] ~= nil)then
			Lootomatic.Data.ListSelect = Lootomatic.DataMirror[Lootomatic_ItemFilterFrame_Itemname:GetText()].Index
		else
			for i=1,table.maxn(Lootomatic_Settings.ItemFilter) do
				if (Lootomatic_Settings.ItemFilter[i]["Name"] == Lootomatic_ItemFilterFrame_Itemname:GetText()) then
					Lootomatic.Data.ListSelect = i;
					break;
				end;
			end;
		end;

end;

function Lootomatic.Func.ItemFilter_CheckEntries(itemname)
	local found1=false;
	local found2=false;
	
	if(Lootomatic.DataMirror[itemname] ~= nil)then
		if (Lootomatic.DataMirror[itemname].Char == nil) then
			found1=Lootomatic.DataMirror[itemname].Index;
		elseif (Lootomatic.DataMirror[itemname].Char==UnitName("player")) then 
			found2=Lootomatic.DataMirror[itemname].Index;
		end;
	end
		
	
	return found1,found2;
end;

function Lootomatic.Func.ItemFilter_SetValues()
	if (Lootomatic.Data.ListSelect == nil) then
		Lootomatic_ItemFilterFrame_Itemname_Text :SetColor(1,1,1);
		Lootomatic_ItemFilterFrame_Filterlist_Highlight:Hide();
	else
		Lootomatic_ItemFilterFrame_Itemname_Text :SetColor(1,0.82,0);
		Lootomatic_ItemFilterFrame_Itemname:SetText(Lootomatic_Settings.ItemFilter[Lootomatic.Data.ListSelect]["Name"]);

		UIDropDownMenu_SetSelectedID(Lootomatic_ItemFilterFrame_Looting, Lootomatic_Settings.ItemFilter[Lootomatic.Data.ListSelect]["Loot"]);
		UIDropDownMenu_SetText      (Lootomatic_ItemFilterFrame_Looting, tostring(Lootomatic.Strings.LootStatus[Lootomatic_Settings.ItemFilter[Lootomatic.Data.ListSelect]["Loot"]]));

		UIDropDownMenu_SetSelectedID(Lootomatic_ItemFilterFrame_Rolling, Lootomatic_Settings.ItemFilter[Lootomatic.Data.ListSelect]["Roll"]);
		UIDropDownMenu_SetText      (Lootomatic_ItemFilterFrame_Rolling, tostring(Lootomatic.Strings.RollStatus[Lootomatic_Settings.ItemFilter[Lootomatic.Data.ListSelect]["Roll"]]));

		local a,b       = Lootomatic_ItemFilterFrame_Filterlist:GetSize();
		local maxvalues = math.floor((b-12)/20);
		local offset    = Lootomatic.Func.ItemFilter_GetDisplayIndex(Lootomatic.Data.ListSelect)-Lootomatic_ItemFilterFrame_ScrollBar:GetValue();

		if (offset>=0 and offset<maxvalues) then
			Lootomatic_ItemFilterFrame_Filterlist_Highlight:ClearAllAnchors();
			Lootomatic_ItemFilterFrame_Filterlist_Highlight:SetAnchor("TOPLEFT", "TOPLEFT", Lootomatic_ItemFilterFrame_Filterlist, 5, 11+offset*20);
			Lootomatic_ItemFilterFrame_Filterlist_Highlight:SetAnchor("BOTTOMRIGHT", "TOPRIGHT", Lootomatic_ItemFilterFrame_Filterlist, -5, 30+offset*20);
			Lootomatic_ItemFilterFrame_Filterlist_Highlight:Show();
		else
			Lootomatic_ItemFilterFrame_Filterlist_Highlight:Hide();
		end;
	end;

	if (string.len(Lootomatic_ItemFilterFrame_Itemname:GetText())==0 or (UIDropDownMenu_GetSelectedID(Lootomatic_ItemFilterFrame_Looting) == 1 and UIDropDownMenu_GetSelectedID(Lootomatic_ItemFilterFrame_Rolling) == 1)) then
		Lootomatic_ItemFilterFrame_ItemAdd:Disable();
	else
		Lootomatic_ItemFilterFrame_ItemAdd:Enable();
	end;

	if (Lootomatic.Data.ListSelect == nil) then
		Lootomatic_ItemFilterFrame_ItemRemove:Disable();
	else
		Lootomatic_ItemFilterFrame_ItemRemove:Enable();
	end;
end;

function Lootomatic.Func.ItemFilter_AddItem(key,itemname,lootmode,rollmode)
	
	if(string.sub((itemname),1,1)=="(")then
		if ((string.sub((itemname),1,8)=="(GLOBAL)"))then
			itemname=string.sub(itemname,9);
		else
			posChar=string.find(itemname,")")
			Lootomatic.Playerbuffer = string.sub(itemname,2,posChar-1);
			itemname=string.sub(itemname,posChar+1);
		end
	end
	
	local found1,found2 = Lootomatic.Func.ItemFilter_CheckEntries(itemname);

	local settings="";
	if (lootmode>1) then settings=settings.."\""..tostring(Lootomatic.Strings.LootStatus[lootmode]).."\""; end;
	if (rollmode>1) then settings=settings.."\""..tostring(Lootomatic.Strings.RollStatus[rollmode]).."\""; end;
	settings=string.gsub(settings,"\"\""," - ");

	if (key=="LBUTTON") then
		if (type(found1)=="number") then
			table.remove(Lootomatic_Settings.ItemFilter,found1);
			Lootomatic.DataMirror[Lootomatic_Settings.ItemFilter[found1].Name] = nil;
		end;
		Lootomatic.Func.AddChatMessage(string.gsub(string.gsub(tostring(Lootomatic.Strings.Added1),"<ITEM>",itemname),"<SETTINGS>",settings));
		table.insert(Lootomatic_Settings.ItemFilter,
			{
			Name = itemname,
			Loot = lootmode,
			Roll = rollmode,
			});
			
		Lootomatic.DataMirror[itemname] ={ Name = itemname, Loot = lootmode, Roll = rollmode,};
		
	elseif (key=="RBUTTON") then
		if (type(found2)=="number") then
			table.remove(Lootomatic_Settings.ItemFilter,found2); 
			Lootomatic.DataMirror[Lootomatic_Settings.ItemFilter[found2].Name] = nil;
		end;
		Lootomatic.Func.AddChatMessage(string.gsub(string.gsub(tostring(Lootomatic.Strings.Added2),"<ITEM>",itemname),"<SETTINGS>",settings));
		if(Lootomatic.Playerbuffer == nil)then
			Lootomatic.Playerbuffer = UnitName("player");
		end
		table.insert(Lootomatic_Settings.ItemFilter,
			{
			Name = itemname,
			Loot = lootmode,
			Roll = rollmode,
			Char = Lootomatic.Playerbuffer,
			});
			if(Lootomatic.Playerbuffer == UnitName("player"))then
				Lootomatic.DataMirror[itemname]= { Name = itemname, Loot = lootmode, Roll = rollmode, Char = Lootomatic.Playerbuffer, };
			end;
			
	end;
	table.sort(Lootomatic_Settings.ItemFilter,Lootomatic.Func.ItemFilter_ListSort);
	Lootomatic.DataMirror = Lootomatic.Func.ItemFilter_SyncList(Lootomatic_Settings.ItemFilter,Lootomatic.DataMirror);
	
	found1,found2 = Lootomatic.Func.ItemFilter_CheckEntries(itemname);

	    if (key=="LBUTTON") then Lootomatic.Data.ListSelect = found1;
	elseif (key=="RBUTTON") then Lootomatic.Data.ListSelect = found2;
	end;
	
	Lootomatic.Playerbuffer = UnitName("player");
	Lootomatic.Func.ItemFilter_Repaint();
	
end;

function Lootomatic.Func.ItemFilter_RemoveItem()
	if (Lootomatic.Data.ListSelect ~= nil) then
		table.remove(Lootomatic_Settings.ItemFilter,Lootomatic.Data.ListSelect);
		Lootomatic.DataMirror[Lootomatic_Settings.ItemFilter[Lootomatic.Data.ListSelect].Name] = nil;
		Lootomatic.Data.ListSelect = nil;
		Lootomatic.Func.ItemFilter_Repaint();
	end;
end;

function Lootomatic.Func.ItemFilter_ListSort(a,b)
	if (string.lower(string.gsub(a.Name,"[\* ]","")) == string.lower(string.gsub(b.Name,"[\* ]",""))) then
		if (a.Char == nil and b.Char ~= nil) then return true;
		else return false; end;
	elseif (string.lower(string.gsub(a.Name,"[\* ]","")) <  string.lower(string.gsub(b.Name,"[\* ]",""))) then return true;
	else return false;
	end;
end;
function Lootomatic.Func.ItemFilter_SyncList(ListA,ListB)

	
	for i,v in pairs(ListA) do
		if( ListB[ListA[i].Name] == nil )then
			ListB[ListA[i].Name] = ListA[i];
			ListB[ListA[i].Name].Index = i;
		else
			if( ListB[ListA[i].Name].Index == nil )then
				ListB[ListA[i].Name].Index = i;
			else
				if( ListB[ListA[i].Name].Index ~= i )then
					if( ListB[ListA[i].Name].Char == nil )then
						ListB[ListA[i].Name].Index = i;
					else
						if( ListB[ListA[i].Name].Char == UnitName("player") )then
							ListB[ListA[i].Name].Index = i;
						end;
					end;
				end;
			end;
		end;
					
	end;
	return ListB;
end

function Lootomatic.Func.ItemFilter_EnterName(name)
	Lootomatic_ItemFilterFrame:Show();
	Lootomatic_ItemFilterFrame_Itemname:SetText(name);
	Lootomatic.Func.ItemFilter_SearchName();
	Lootomatic.Func.ItemFilter_SetValues();
end;

function Lootomatic.Func.ItemFilter_LootmenuItems()
	local menuitem;

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.LootStatus[1]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_LootmenuChange(1); end;
	UIDropDownMenu_AddButton(menuitem,1);

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.LootStatus[2]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_LootmenuChange(2); end;
	UIDropDownMenu_AddButton(menuitem,1);

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.LootStatus[3]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_LootmenuChange(3); end;
	UIDropDownMenu_AddButton(menuitem,1);

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.LootStatus[4]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_LootmenuChange(4); end;
	UIDropDownMenu_AddButton(menuitem,1);
end;

function Lootomatic.Func.ItemFilter_LootmenuChange(set)
	if (Lootomatic.Data.ListSelect ~= nil) then Lootomatic_Settings.ItemFilter[Lootomatic.Data.ListSelect]["Loot"] = set; end;
	UIDropDownMenu_SetSelectedID(Lootomatic_ItemFilterFrame_Looting, set);
	Lootomatic.Func.ItemFilter_Repaint();
end;

function Lootomatic.Func.ItemFilter_RollmenuItems()
	local menuitem;

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.RollStatus[1]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_RollmenuChange(1); end;
	UIDropDownMenu_AddButton(menuitem,1);

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.RollStatus[2]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_RollmenuChange(2); end;
	UIDropDownMenu_AddButton(menuitem,1);

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.RollStatus[3]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_RollmenuChange(3); end;
	UIDropDownMenu_AddButton(menuitem,1);

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.RollStatus[4]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_RollmenuChange(4); end;
	UIDropDownMenu_AddButton(menuitem,1);

	menuitem = {};
	menuitem.text = tostring(Lootomatic.Strings.RollStatus[5]);
	menuitem.func = function() Lootomatic.Func.ItemFilter_RollmenuChange(5); end;
	UIDropDownMenu_AddButton(menuitem,1);
end;

function Lootomatic.Func.ItemFilter_RollmenuChange(set)
	if (Lootomatic.Data.ListSelect ~= nil) then Lootomatic_Settings.ItemFilter[Lootomatic.Data.ListSelect]["Roll"] = set; end;
	UIDropDownMenu_SetSelectedID(Lootomatic_ItemFilterFrame_Rolling, set);
	Lootomatic.Func.ItemFilter_Repaint();
end;

function Lootomatic.Func.ItemFilter_ReceiveDrag(this)
	if ( CursorItemType() == "bag" ) then
		local id = GetCursorItemInfo();
		local icon, name, count = GetGoodsItemInfo(id);
		Lootomatic.Func.ItemFilter_EnterName(name);
		Lootomatic_ItemFilterFrame_Itemname:ClearFocus();
		PickupBagItem(id);
	end
end;

function Lootomatic.Func.DropTab_Receive(key,this)
	if ( this:GetParent().itemname~=nil ) then
		local x=string.gsub(this:GetName(),"^.*_","");
		local loot = tonumber(string.sub(x,1,1))+1;
		local roll = tonumber(string.sub(x,2))+1;

		if (loot==1 and roll==1) then
			local found1,found2 = Lootomatic.Func.ItemFilter_CheckEntries(this:GetParent().itemname);

			if (key=="LBUTTON") then
				if (found1~=false) then
					table.remove(Lootomatic_Settings.ItemFilter,found1);
					Lootomatic.DataMirror[Lootomatic_Settings.ItemFilter[found1].Name] = nil;
					if (found1 == Lootomatic.Data.ListSelect) then
						Lootomatic.Data.ListSelect = nil;
					end;
					Lootomatic.Func.AddChatMessage(string.gsub(tostring(Lootomatic.Strings.Removed1),"<ITEM>",this:GetParent().itemname));
				else
					Lootomatic.Func.AddChatMessage(string.gsub(tostring(Lootomatic.Strings.NotFound1),"<ITEM>",this:GetParent().itemname));
				end;
			elseif (key=="RBUTTON") then
				if (found2~=false) then
					table.remove(Lootomatic_Settings.ItemFilter,found2);
					Lootomatic.DataMirror[Lootomatic_Settings.ItemFilter[found2].Name] = nil;
					if (found2 == Lootomatic.Data.ListSelect) then
						Lootomatic.Data.ListSelect = nil;
					end;
					Lootomatic.Func.AddChatMessage(string.gsub(tostring(Lootomatic.Strings.Removed2),"<ITEM>",this:GetParent().itemname));
				else
					Lootomatic.Func.AddChatMessage(string.gsub(tostring(Lootomatic.Strings.NotFound2),"<ITEM>",this:GetParent().itemname));
				end;
			end;

			Lootomatic.Func.ItemFilter_Repaint();
		else
			Lootomatic.Func.ItemFilter_AddItem(key,this:GetParent().itemname,loot,roll);
		end;

		this:GetParent():Hide();

		if (this:GetParent().id ~= nil) then
			PickupBagItem(this:GetParent().id);
		end;
	end
end;

function Lootomatic.Func.ItemFilter_Scroll(delta)
	    if (delta>0) then Lootomatic_ItemFilterFrame_ScrollBar:SetValue(Lootomatic_ItemFilterFrame_ScrollBar:GetValue()-1);
	elseif (delta<0) then Lootomatic_ItemFilterFrame_ScrollBar:SetValue(Lootomatic_ItemFilterFrame_ScrollBar:GetValue()+1); end;
end;

function Lootomatic.Func.FadeFrames(value,force)
	if (type(value)=="number") then
		for n=table.maxn(Lootomatic.Data.Fade),1,-1 do
			if (Lootomatic.Data.Fade[n]~=nil) then
				-- iterate value
				Lootomatic.Data.Fade[n][2]=Lootomatic.Data.Fade[n][2]+Lootomatic.Data.Fade[n][3]*value*5;

				-- check for max/min
				local complete=false;
				if (Lootomatic.Data.Fade[n][2]>=1 and Lootomatic.Data.Fade[n][3]== 1) then Lootomatic.Data.Fade[n][2]=1; complete=true; end;
				if (Lootomatic.Data.Fade[n][2]<=0 and Lootomatic.Data.Fade[n][3]==-1) then Lootomatic.Data.Fade[n][2]=0; complete=true; end;

				-- set scale/alpha
				getglobal(Lootomatic.Data.Fade[n][1]):SetAlpha((Lootomatic.Data.Fade[n][2]        ));
				getglobal(Lootomatic.Data.Fade[n][1]):SetScale((Lootomatic.Data.Fade[n][2]*0.1+0.9));

				-- set visibility
				if (getglobal(Lootomatic.Data.Fade[n][1]):GetAlpha()>0) then
					getglobal(Lootomatic.Data.Fade[n][1]):Show();
				else
					getglobal(Lootomatic.Data.Fade[n][1]):Hide();
					-- Reset values after hiding window, to prevent showing faded frames through addonmanager
					getglobal(Lootomatic.Data.Fade[n][1]):SetAlpha(1);
					getglobal(Lootomatic.Data.Fade[n][1]):SetScale(1);
				end;

				-- remove completed frame
				if (complete) then table.remove(Lootomatic.Data.Fade,n); end;
			end;
		end;
	elseif (type(value)=="string") then
		local i,j;
		if (getglobal(value):IsVisible()) then
			i=1; j=-1;
		else
			i=0; j= 1;
		end;

		for n=1,table.maxn(Lootomatic.Data.Fade) do
			if (value==Lootomatic.Data.Fade[n][1]) then
				i= Lootomatic.Data.Fade[n][2];
				j=-Lootomatic.Data.Fade[n][3];
				table.remove(Lootomatic.Data.Fade,n);
				break;
			end;
		end;

		if (force~=nil) then j=force; end;

		table.insert(Lootomatic.Data.Fade,{value,i,j});
	end;
end;

----------------------------------------------------------------------------------------------------------
-- CHANGELOG
----------------------------------------------------------------------------------------------------------
--   v0.6c to v1.0:
--      + Importing old settings, when new version is detected
--      + Fixed bug when searching bag for trashitems
--      + Fixed bug with table of chatmessages to block
--      + Added button in Droptab that removes items from the Itemfilter
--      + Fixed option that hides rollresults in chatframe
--      + Enhanced rollresults to new displaystyle: Item - Player - Rollresult
--      + Enhanced rollresultsettings for individual display of need/greed/pass
--      + Added feature that automatically deactivates Ingame-Autolooting
--      + renewed all localfiles
--      + All frames are now fading
--   TODO:
--      - Possibility to select key, that adds items to Itemfilter when clicking a button in Rollframe
----------------------------------------------------------------------------------------------------------
-- EOF -- Lootomatic, written by PetraAreon
